      subroutine me602( kfgen, p, ans, iret )
C  Calculate the matrix element of the process 602: u ubar -> AA + g.
C  iret = 0 if reasonablly evaluated.
      implicit real*8(a-h,o-z)
      include 'incl6021.h'
      include 'inclk.h'

      parameter ( nextrn= 5, nextrn0= nextrn -1 )
      integer kfgen(nextrn)
      real*8 p(4,nextrn)
      real*8 bdir(3),ptemp(4),p0(4,nextrn0)

C  Return with non-zero "iret" if the radiation is soft.
      ans= 0.d0
      iret= 1

      irad= 5
      do imoth=1,2
         do i=1,4
            ptemp(i)= p(i,imoth) -p(i,irad)
         enddo
         qsq= ptemp(1)**2 +ptemp(2)**2 +ptemp(3)**2 -ptemp(4)**2
         if( imoth.eq.1 ) then
            call bstcm( ptemp, p(1,2),
     >           pcm, ecm1, ecm2, bdir, gamma, phi, theta )
         else
            call bstcm( p(1,1), ptemp,
     >           pcm, ecm1, ecm2, bdir, gamma, phi, theta )
         endif
         pini= ( ecm1 +ecm2 )/2.d0
         p0(1,1)= 0.d0
         p0(2,1)= 0.d0
         p0(3,1)= pini
         p0(4,1)= pini
         p0(1,2)= 0.d0
         p0(2,2)= 0.d0
         p0(3,2)= -pini
         p0(4,2)= pini
         j= 2
         do i=3,nextrn
            if( i.ne.irad ) then
               j= j +1
               call bstfw( p(1,i), 
     >              bdir, gamma, phi, theta, p0(1,j) )
            endif
         enddo
         call setscale( 600, p0, qren, qfac )
         if( qsq.lt.qfac**2 ) return
      enddo

C  The radiation is hard enough.
      call g602finit
      call a602mclr
C      call amparm

      do i=1,nextrn
         kfcode(i)= kfgen(i)
      enddo

      ireg= 1
      call grcusrfnc602(ireg)

      do i=1,4
         pe6021(i) = p(i,1)
         pe6022(i) = p(i,2)
         pe6023(i) = p(i,3)
         pe6024(i) = p(i,4)
         pe6025(i) = p(i,5)
      enddo

      do i=1,nextrn
         do j=1,nextrn
            prod(i,j) = p(4,i)*p(4,j) -p(1,i)*p(1,j) 
     >           - p(2,i)*p(2,j) -p(3,i)*p(3,j)
         enddo
      enddo

      do i=1,nextrn
         amass2(i)= p(4,i)**2 -p(3,i)**2 -p(2,i)**2 -p(1,i)**2
         if( amass2(i).lt.0.d0 ) amass2(i)= 0.d0
         amass1(i)= sqrt( amass2(i) )
      enddo

      call a602kptbl
      call a602mptbl
      call a602mpsum( ansm )
      ans= ansm*aspin

      iret= 0

      return
      end
