      PROGRAM main
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INCLUDE 'inclk.h'
      INCLUDE 'grchad.inc'

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

      EXTERNAL DRN
      INTEGER IEV,IDUMMY,IGSEC
      DOUBLE PRECISION SUMXSEC,CRAN

C  PSKINI information
      common/PSKfail/ ifail_pskini,nfail_pskini

C...Statement to link the block data; comment out if any trouble.
C      EXTERNAL GRCBLOCKD

      character*80 lhafile

      parameter ( lhcom = 100000 )
      real*4 h
      common /pawc/h(lhcom)
      character*72 flhist
      real*4 weight

C------------------------------------------------------------------
C  Cut to the generated events.
      parameter ( ptcut1= 20.d0, ptcut2= 35.d0 )
      parameter ( etacut= 3.0d0 )
      parameter ( amcut1= 0.d0, amcut2= 99999.d0 )
C------------------------------------------------------------------
C  Delta-R for two-gamma separation.
      parameter ( drsepa= 0.d0 )
C------------------------------------------------------------------
C  For gamma-gamma process
      integer ipgam(2)
      real*8 pAA(4)
      real*8 evpos(2),evneg(2)
      logical addgen/.false./

C-----------------------------------------------------------------------
C  Add the parton-level "gam gam + jet" info. to the LHA event file.
C  Turn off unless the read routine can handle this info. properly.
C-----------------------------------------------------------------------
      addgen= .true.
C-----------------------------------------------------------------------
C  Output hbook file; "*" for no output.
C      flhist= '*'
      flhist= 'hist.hbook'
C-----------------------------------------------------------------------
C  Number of events to generate.
C-----------------------------------------------------------------------
      nevent= 10000
C-----------------------------------------------------------------------
C  Logical unit number for the output event file; 0 for no output.
C      lunwrit= 0
      lunwrit= 20
C-----------------------------------------------------------------------
      if( lunwrit.gt.0 ) then
C  (ASCII file)
         ifmt= 0
         lhafile= 'lhaext_aa1j_matched_asc.dat'
         open(lunwrit,file=lhafile,form='FORMATTED',status='NEW')
C  (binary file)
C         ifmt= 1
C         lhafile= 'lhaext_bin.dat'
C         open(lunwrit,file=lhafile,form='UNFORMATTED',status='NEW')
C  (LHA event file)
C         ifmt= 2
C         lhafile= 'lhaext.lhe'
C         open(lunwrit,file=lhafile,form='FORMATTED',status='NEW')
      endif
C-----------------------------------------------------------------------
C  Book histograms.
C-----------------------------------------------------------------------
      call hlimit(lhcom)

      call hbook1(1,'pt smaller of A (gen)$',100,0.,100.,0.)
      call hbook1(2,'pt larger of A (gen)$',100,0.,100.,0.)
      call hbook1(3,'eta of A (gen)$',100,-5.,5.,0.)
      call hbook1(4,'Delta-R of AA (gen)$',100,0.,5.,0.)
      call hbook1(5,'Num. of ISR jets$',100,0.,100.,0.)
      call hbook1(6,'Num. of FSR jets$',100,0.,100.,0.)
      call hbook1(7,'Num. of particles$',100,0.,100.,0.)

      call hbook1(10,'pt smaller of A$',100,0.,200.,0.)
      call hbook1(11,'pt larger of A$',100,0.,200.,0.)
      call hbook1(12,'phi of A$',100,-3.1416,3.1416,0.)
      call hbook1(13,'eta of A$',100,-5.,5.,0.)
      call hbook1(14,'Delta_phi of AA$',100,0.,3.1416,0.)
      call hbook1(15,'Delta_eta of AA$',100,0.,5.,0.)
      call hbook1(16,'Delta_R of AA$',100,0.,5.,0.)

      call hbook1(20,'pt smaller of A (weighted)$',100,0.,200.,0.)
      call hbook1(21,'pt larger of A (weighted)$',100,0.,200.,0.)
      call hbook1(22,'eta of A (weighted)$',100,-5.,5.,0.)
      call hbook1(23,'Delta_R of AA (weighted)$',100,0.,5.,0.)
      call hbook1(24,'mass of AA (weighted)$',100,0.,200.,0.)
      call hbook1(25,'pt of AA (weighted)$',100,0.,200.,0.)
      call hbook1(26,'rapidity of AA (weighted)$',100,-5.,5.,0.)

      call hbook1(30,'pt smaller of A (selected)$',100,0.,200.,0.)
      call hbook1(31,'pt larger of A (selected)$',100,0.,200.,0.)
      call hbook1(32,'eta of A (selected)$',100,-5.,5.,0.)
      call hbook1(33,'Delta_R of AA (selected)$',100,0.,5.,0.)
      call hbook1(34,'mass of AA (selected)$',100,0.,200.,0.)
      call hbook1(35,'pt of AA (selected)$',100,0.,200.,0.)
      call hbook1(36,'rapidity of AA (selected)$',100,-5.,5.,0.)

      call hbook1(40,'pt smaller of A (gen)$',100,0.,100.,0.)
      call hbook1(41,'pt larger of A (gen)$',100,0.,100.,0.)
      call hbook1(42,'eta of A (gen)$',100,-5.,5.,0.)
      call hbook1(43,'Delta-R of AA (gen)$',100,0.,5.,0.)
C-----------------------------------------------------------------------
C...Initialization.
      CALL UPINIT
      call RUPdump

C  Output the header data.
      if( lunwrit.gt.0 ) then
         if( ifmt.eq.0 ) then
            call lhaWritHdAsc(lunwrit)
         elseif( ifmt.eq.1 ) then
            call lhaWritHdBin(lunwrit)
         elseif( ifmt.eq.2 ) then
            call lhaWritHdLhef(lunwrit)
         endif
      endif

C  Sum of the cross sections.
      SUMXSEC = 0.0D0
      DO I = 1,NPRUP
         SUMXSEC = XSECUP(i) + SUMXSEC
      ENDDO

C...Event loop.
      WRITE(*,'(/10X,''########## Start generating events ##########''
     >     )')

      do i=1,2
         evpos(i)= 0.d0
         evneg(i)= 0.d0
      enddo

      DO IEV = 1,nevent

C...Event generation.

C  Process selection.
         CRAN = DRN(IDUMMY)*SUMXSEC
         IGSEC = 0
         DO WHILE (CRAN.GT.0.0D0)
            IGSEC = IGSEC + 1
            CRAN = CRAN - XSECUP(IGSEC)
         ENDDO
         IDPRUP = LPRUP(IGSEC)

C  Generation
         CALL UPEVNT

         if( nevent.le.1000 ) then
            IF (IEV.LE.2 .OR. MOD(IEV,100).EQ.0) THEN
               WRITE(*,*) ' '
               WRITE(*,*) 'Event# ',IEV
               call EUPdump
            ENDIF
         else
            IF (IEV.LE.5) THEN
               WRITE(*,*) ' '
               WRITE(*,*) 'Event# ',IEV
               call EUPdump
            ELSEIF (MOD(IEV,1000).EQ.0) THEN
               WRITE(*,*) 'Event# ',IEV
            ENDIF
         endif

         if( XWGTUP.ge.0.d0 ) then
            weight= 1.
            evpos(1)= evpos(1) +1.d0
         else
            weight= -1.
            evneg(1)= evneg(1) +1.d0
         endif

C  Info before PS applied.
         etacm= log( GPRI(5)/GPRI(6) )/2.d0

         call pteta( pgrc(1,3), ptgen1, etagen1 )
         etagen1= etacm +etagen1
         call pteta( pgrc(1,4), ptgen2, etagen2 )
         etagen2= etacm +etagen2

         dRgen= delta_r( pgrc(1,3), pgrc(1,4) )

         if( ptgen1.le.ptgen2 ) then
            call hf1(1,real(ptgen1),1.)
            call hf1(2,real(ptgen2),1.)
         else
            call hf1(1,real(ptgen2),1.)
            call hf1(2,real(ptgen1),1.)
         endif
         call hf1(3,real(etagen1),1.)
         call hf1(3,real(etagen2),1.)
         call hf1(4,real(dRgen),1.)

C  Generaged events.
         ngam= 0
         nisr= 0
         nfsr= 0
         do i=1,NUP
            if( IDUP(i).eq.22 ) then
               ngam= ngam +1
               if( ngam.le.2 ) ipgam(ngam)= i
            endif
            if( ISTUP(i).eq.1 .and. MOTHUP(1,i).le.2 .and. 
     >           MOTHUP(2,i).eq.0 ) nisr= nisr +1
            if( ISTUP(i).eq.1 .and. MOTHUP(1,i).eq.1 .and. 
     >           MOTHUP(2,i).eq.2 ) nfsr= nfsr +1
         enddo
         if( ngam.ne.2 ) then
            call EUPdump
            if( ngam.ne.2 ) then
               print *,'!!! Number of gammas not equal to 2 !!!'
            endif
            stop
         endif
         call hf1(5,nisr+.5,1.)
         call hf1(6,nfsr+.5,1.)
         call hf1(7,NUP+.5,1.)

         call pteta( PUP(1,ipgam(1)), pt1, eta1 )
         call pteta( PUP(1,ipgam(2)), pt2, eta2 )
         phi1= atan2( PUP(2,ipgam(1)), PUP(1,ipgam(1)) )
         phi2= atan2( PUP(2,ipgam(2)), PUP(1,ipgam(2)) )
         if( pt1.le.pt2 ) then
            call hf1(10,real(pt1),1.)
            call hf1(11,real(pt2),1.)
         else
            call hf1(10,real(pt2),1.)
            call hf1(11,real(pt1),1.)
         endif
         call hf1(12,real(phi1),1.)
         call hf1(12,real(phi2),1.)
         call hf1(13,real(eta1),1.)
         call hf1(13,real(eta2),1.)

         csphi= ( PUP(1,ipgam(1))*PUP(1,ipgam(2))
     >        +PUP(2,ipgam(1))*PUP(2,ipgam(2)) )/pt1/pt2
         if( csphi.gt.1.d0 ) csphi= 1.d0
         if( csphi.lt.-1.d0 ) csphi= -1.d0
         dphi= acos( csphi )
         deta= abs( eta1 -eta2 )
         dR= sqrt( dphi**2 +deta**2 )
         call hf1(14,real(dphi),1.)
         call hf1(15,real(deta),1.)
         call hf1(16,real(dR),1.)

C  Weighted.
         if( pt1.le.pt2 ) then
            call hf1(20,real(pt1),weight)
            call hf1(21,real(pt2),weight)
         else
            call hf1(20,real(pt2),weight)
            call hf1(21,real(pt1),weight)
         endif
         call hf1(22,real(eta1),weight)
         call hf1(22,real(eta2),weight)
         call hf1(23,real(dR),weight)
         do i=1,4
            pAA(i)= PUP(i,ipgam(1)) +PUP(i,ipgam(2))
         enddo
         amAA= sqrt( pAA(4)**2 -pAA(3)**2 -pAA(2)**2 -pAA(1)**2 )
         ptAA= sqrt( pAA(1)**2 +pAA(2)**2 )
         rapAA= log( ( pAA(4) +pAA(3) )/( pAA(4) -pAA(3) ) )/2.d0
         call hf1(24,real(amAA),weight)
         call hf1(25,real(ptAA),weight)
         call hf1(26,real(rapAA),weight)

C  Selection.
         if( pt1.lt.ptcut1 .or. pt2.lt.ptcut1 ) goto 9
         if( pt1.lt.ptcut2 .and. pt2.lt.ptcut2 ) goto 9
         if( abs( eta1 ).gt.etacut .or. abs( eta2 ).gt.etacut )
     >        goto 9
         if( amAA.lt.amcut1 .or. amAA.gt.amcut2 ) goto 9
         if( dR.lt.drsepa ) goto 9

         if( XWGTUP.ge.0.d0 ) then
            evpos(2)= evpos(2) +1.d0
         else
            evneg(2)= evneg(2) +1.d0
         endif

C  Selected events.
         if( pt1.le.pt2 ) then
            call hf1(30,real(pt1),weight)
            call hf1(31,real(pt2),weight)
         else
            call hf1(30,real(pt2),weight)
            call hf1(31,real(pt1),weight)
         endif
         call hf1(32,real(eta1),weight)
         call hf1(32,real(eta2),weight)
         call hf1(33,real(dR),weight)
         do i=1,4
            pAA(i)= PUP(i,ipgam(1)) +PUP(i,ipgam(2))
         enddo
         amAA= sqrt( pAA(4)**2 -pAA(3)**2 -pAA(2)**2 -pAA(1)**2 )
         ptAA= sqrt( pAA(1)**2 +pAA(2)**2 )
         rapAA= log( ( pAA(4) +pAA(3) )/( pAA(4) -pAA(3) ) )/2.d0
         call hf1(34,real(amAA),weight)
         call hf1(35,real(ptAA),weight)
         call hf1(36,real(rapAA),weight)

C  Add the generation info.
         if( addgen ) then
            ip= NUP
            do i=1,NNF
               ip= ip +1
               IDUP(ip)= kfcode(i)
               ISTUP(ip)= 100
               if( i.eq.1 ) then
                  PUP(1,ip) = 0.0D0
                  PUP(2,ip) = 0.0D0
                  PUP(3,ip) = 0.5D0*GPRI(5)*GRCECM
                  PUP(4,ip) = 0.5D0*GPRI(5)*GRCECM
                  PUP(5,ip) = 0.0D0
               elseif( i.eq.2 ) then
                  PUP(1,ip) = 0.0D0
                  PUP(2,ip) = 0.0D0
                  PUP(3,ip) = -0.5D0*GPRI(5)*GRCECM
                  PUP(4,ip) = 0.5D0*GPRI(5)*GRCECM
                  PUP(5,ip) = 0.0D0
               else
                  PUP(1,ip) = PGRC(1,i)
                  PUP(2,ip) = PGRC(2,i)
                  PUP(3,ip) = GPRI(8)*(PGRC(3,i) + GPRI(7)*PGRC(4,i))
                  PUP(4,ip) = GPRI(8)*(PGRC(4,i) + GPRI(7)*PGRC(3,i))
                  PUP(5,ip) = AMASS1(i)
               endif
            enddo
            NUP= NUP +NNF
         endif

C  Output the event data.
         if( lunwrit.gt.0 ) then
            if( ifmt.eq.0 ) then
               call lhaWritEvAsc(lunwrit)
            elseif( ifmt.eq.1 ) then
               call lhaWritEvBin(lunwrit)
            elseif( ifmt.eq.2 ) then
               call lhaWritEvLhef(lunwrit)
            endif
         endif

C  Check the generation condition.
         if( ptgen1.le.ptgen2 ) then
            call hf1(40,real(ptgen1),1.)
            call hf1(41,real(ptgen2),1.)
         else
            call hf1(40,real(ptgen2),1.)
            call hf1(41,real(ptgen1),1.)
         endif
         call hf1(42,real(etagen1),1.)
         call hf1(42,real(etagen2),1.)
         call hf1(43,real(dRgen),1.)

 9       continue
      ENDDO

      WRITE(*,'(/8X,''########## Event generation completed ##########''
     >     )')
      print *,'Total number of failure returns from PSKINI',
     >     nfail_pskini
      print *,'Do not warry unless too large; e.g., more than 1%.'

C  Summary
      print *,' '
      print *,'---------- Summary ----------'
      xabs= SUMXSEC
      print '('' Integrated absolute cross section = '',E12.6,
     >     '' pb'')', xabs
      evtot= evpos(1) +evneg(1)
      evdif= evpos(1) -evneg(1)
      rneg= evneg(1)/evtot
      print '(F10.0,'' events generated in total'')', evtot
      print '(F10.0,'' positive, and '',F10.0,
     >     '' negative weight events'')', evpos(1),evneg(1)
      print '('' Negative weight fraction = '',F10.6)', rneg
      xsec= xabs*evdif/evtot
      xerr= xabs/sqrt( evtot )
      print '('' True cross section = '',E12.6,'' +-'',E12.6
     >     '' pb'')', xsec,xerr
      print *,'--- selection ---'
      evsel= evpos(2) +evneg(2)
      print '(F10.0,'' events selected'')', evsel
      effsel= evsel/evtot
      errsel= sqrt( effsel*( 1.d0 -effsel)/evtot )
      print '('' Selection efficiency = '',F8.4,'' +- '',F8.4)',
     >     effsel,errsel
      xabs= SUMXSEC*effsel
      xerr= SUMXSEC*errsel
      print '('' Integrated absolute cross section = '',E12.6,
     >     '' +- '',E12.6,'' pb'')', xabs,xerr
      rneg= evneg(2)/evsel
      errneg= sqrt( rneg*( 1.d0 -rneg )/evsel )
      print '(F10.0,'' positive, and '',F10.0,
     >     '' negative weight events'')', evpos(2),evneg(2)
      print '('' Negative weight fraction = '',F10.6,
     >     '' +- '',F10.6)', rneg,errneg
      evdif= evpos(2) -evneg(2)
      pnasym= evdif/evsel
      xsec= SUMXSEC*effsel*pnasym
      xerr= xsec*sqrt( ( 1.d0 -effsel)/effsel/evtot
     >     +( 1.d0 -pnasym)/pnasym/evsel )
      print '('' True cross section = '',E12.6,'' +-'',E12.6
     >     '' pb'')', xsec,xerr
      print *,'-----------------------------'

C  Close the event output file.
      if( lunwrit.gt.0 ) then
         if( ifmt.eq.2 ) then
            call lhaWritEndLhef(lunwrit)
         endif
         close(lunwrit)
      endif

C  Generation information.
      if( lunwrit.gt.0 ) then
         lun= 30
         open(lun,file='generation.txt',form='FORMATTED',
     >        status='UNKNOWN')
         write(lun,'(F10.0,'' events generated'')') evtot
         write(lun,'(F10.0,'' events written'')') evsel
         close(lun)
      endif

C...Histograms.
      call histdo
C
C -- Store histograms.
C
      if( flhist(1:1).NE.'*' ) then
        call hrput(0,flhist,'N')
      endif

      stop
      END

      subroutine pteta( p, pt, eta )
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      real*8 p(3)

      pt2= p(1)**2 +p(2)**2
      pabs= sqrt( pt2 +p(3)**2 )
      pt= sqrt( pt2 )
      eta= log( ( pabs +abs( p(3) ) )/pt )
      if( p(3).lt.0.d0 ) eta= -eta

      return
      end

      real*8 function delta_r( p1, p2 )
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      real*8 p1(4),p2(4)

      call pteta( p1, pt1, eta1 )
      call pteta( p2, pt2, eta2 )
      csphi= ( p1(1)*p2(1) +p1(2)*p2(2) )/pt1/pt2
      if( csphi.gt.1.d0 ) csphi= 1.d0
      if( csphi.lt.-1.d0 ) csphi= -1.d0
      dphi= acos( csphi )
      delta_r= sqrt( dphi**2 +( eta1 -eta2 )**2 )

      return
      end
