      PROGRAM Pythia
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

      INTEGER PYK,PYCHGE,PYCOMP
C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Standard PYTHIA commonblocks.
      INTEGER N,NPAD,K
      REAL*8 P,V
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      INTEGER MSTU,MSTJ
      REAL*8 PARU,PARJ
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      INTEGER MDCY,MDME,KFDP
      REAL*8 BRAT
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      INTEGER MSEL,MSELPD,MSUB,KFIN
      REAL*8 CKIN
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
      INTEGER MSTP,MSTI
      REAL*8 PARP,PARI
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

      character*80 lhafile

      parameter ( lhcom = 100000 )
      real*4 h
      common /pawc/h(lhcom)
      character*72 flhist
      real*4 weight

C------------------------------------------------------------------
C  Cut to the generated events.
      parameter ( ptcut1= 25.d0, ptcut2= 40.d0 )
      parameter ( etacut= 2.5d0 )
      parameter ( amcut1= 80.d0, amcut2= 140.d0 )
C------------------------------------------------------------------
C  Delta-R for two-gamma separation.
      parameter ( drsepa= 0.4d0 )
C------------------------------------------------------------------
C  Isolation cut.
C      parameter ( driso= 0.4d0, etisocut= 3.0d0 )
      parameter ( driso= 0.4d0, etisocut= 15.0d0 )
C------------------------------------------------------------------
      real*8 evread(0:3),evpos(0:3),evneg(0:3)
      integer ipgam0(2),ipgam(10)
      real*8 pgam(4,2),pAA(4)
      real*8 etiso(2),ptest(4)

C  Original hard interaction information.
      integer nporig,iprorig,kforig
      real*8 porig
      common /info_orig/nporig,iprorig,kforig(10),porig(5,10)

C-----------------------------------------------------------------------
C  Output hbook file; "*" for no output.
C-----------------------------------------------------------------------
C      flhist= '*'
      flhist= 'hist.hbook'
C-----------------------------------------------------------------------
C  Number of events. 
C-----------------------------------------------------------------------
C      NEV = 10000
      NEV = 99999999                 ! Number of events
C-----------------------------------------------------------------------
C  PS/MI choice in Pythia.
C-----------------------------------------------------------------------
C      MSTP(61)  = 0   ! no ISR
C      MSTP(71)  = 0   ! no FSR
C      MSTP(81)  = 0   ! no MI, old PS when PYEVNT called
C      MSTP(81)  = 1   ! MI on, old PS when PYEVNT called (default)
C      MSTP(81)  = 20  ! no MI, new PS (= PYEVNW)
C      MSTP(81)  = 21  ! MI on, new PS (= PYEVNW)
C      MSTP(111) = 0   ! no hadronization
C-----------------------------------------------------------------------
C  Reset the energy-scale factor
C-----------------------------------------------------------------------
C  The default value of PARP(67) for the "old" PS is not suitable.
C  Comment out when the "new" PS is chosen.
      PARP(67)= 1.0    ! ISR energy scale factor for the "old" PS.
      PARP(71)= 1.0    ! FSR energy scale factor.
C-----------------------------------------------------------------------
C   PDF choice
C-----------------------------------------------------------------------
C      mstp(51)= 1         ! CTEQ3L
C      mstp(51)= 4         ! GRV 94L
C      mstp(51)= 7         ! CTEQ5L (default)
C      mstp(51)= 11        ! GRV 92L
C      mstp(51)= 12        ! EHLQ set 1
C      mstp(58)= 5         ! Nr. of flavor in PDF 
C-----------------------------------------------------------------------
C  Initialization
C-----------------------------------------------------------------------
C  UPINIT is called in PYINIT.
      CALL PYINIT('USER',' ',' ',0,0d0)
C-----------------------------------------------------------------------
C  Print out the parameters
C-----------------------------------------------------------------------
C  Basic control
      print *,'PS, multiple-interaction, hadronization:'
      print *,'  mstp(61, 71, 81, 111) =',mstp(61),mstp(71),
     >     mstp(81),mstp(111)
      print *,'PDF choice: mstp(51) =',mstp(51),
     >     ' with NF: mstp(58) =',mstp(58)

C  Energy scale factors
      print *,'Energy scale factors:'
      print '(5X,''parp(67), parp(71) ='',2F10.3)', parp(67),parp(71)

C  Multiple interaction
      print *,'Multiple interaction model: mstp(82) = ',mstp(82)
      print '(5X,''parp(82) ='',F10.3)', parp(82)
      print '(5X,''parp(83), parp(84) ='',2F10.3)', parp(83),parp(84)
      print '(5X,''parp(85), parp(86) ='',2F10.3)', parp(85),parp(86)
      print '(5X,''parp(89), parp(90) ='',2F10.3)', parp(89),parp(90)

C  Primordial kT
      print *,'Primordial kT mode: mstp(91) = ',mstp(91)
      print '(5X,''parp(91), parp(93) = '',2F10.3)',parp(91),parp(93)

C...Book histograms.
      call hlimit(lhcom)

      call hbook1(1,'pt smaller (before sel)$',100,0.,100.,0.)
      call hbook1(2,'pt larger (before sel)$',100,0.,100.,0.)
      call hbook1(3,'eta of A (before sel)$',100,-5.,5.,0.)
      call hbook1(4,'Delta_R of AA (before sel)$',100,0.,5.,0.)
      call hbook1(5,'mass of AA (before sel)$',100,0.,200.,0.)
      call hbook1(6,'ETiso of A$',100,0.,100.,0.)

      call hbook1(10,'pt smaller (abs)$',100,0.,100.,0.)
      call hbook1(11,'pt larger (abs)$',100,0.,100.,0.)
      call hbook1(12,'eta of A (abs)$',100,-5.,5.,0.)
      call hbook1(13,'Delta_R of AA (abs)$',100,0.,5.,0.)
      call hbook1(14,'mass of AA (abs)$',100,0.,200.,0.)
      call hbook1(15,'pt of AA (abs)$',100,0.,200.,0.)
      call hbook1(16,'rapidity of AA (abs)$',100,-5.,5.,0.)
      call hbook1(17,'Delta_phi of AA (abs)$',20,0.,3.1416,0.)

      call hbook1(20,'pt smaller$',100,0.,100.,0.)
      call hbook1(21,'pt larger$',100,0.,100.,0.)
      call hbook1(22,'eta of A$',100,-5.,5.,0.)
      call hbook1(23,'Delta_R of AA$',100,0.,5.,0.)
      call hbook1(24,'mass of AA$',100,0.,200.,0.)
      call hbook1(25,'pt of AA$',100,0.,200.,0.)
      call hbook1(26,'rapidity of AA$',100,-5.,5.,0.)
      call hbook1(27,'Delta_phi of AA$',20,0.,3.1416,0.)

      call hbook1(30,'pt of AA (gamgam)$',100,0.,200.,0.)
      call hbook1(31,'Delta_phi of AA (gamgam)$',20,0.,3.1416,0.)
      call hbook1(32,'pt of AA (gamgam+q)$',100,0.,200.,0.)
      call hbook1(33,'Delta_phi of AA (gamgam+q)$',20,0.,3.1416,0.)
      call hbook1(34,'pt of AA (gamgam+g)$',100,0.,200.,0.)
      call hbook1(35,'Delta_phi of AA (gamgam+g)$',20,0.,3.1416,0.)

      call hbook1(40,'pt smaller (LHA input)$',100,0.,100.,0.)
      call hbook1(41,'pt larger (LHA input)$',100,0.,100.,0.)
      call hbook1(42,'eta of A (LHA input)$',100,-5.,5.,0.)
      call hbook1(43,'Delta_R of AA (LHA input)$',100,0.,5.,0.)

      call hbook1(50,'pt smaller of A (gen)$',100,0.,100.,0.)
      call hbook1(51,'pt larger of A (gen)$',100,0.,100.,0.)
      call hbook1(52,'eta of A (gen)$',100,-5.,5.,0.)
      call hbook1(53,'Delta_R of AA (gen)$',100,0.,5.,0.)

      call hbook1(54,'Delta_R of AJ$',100,0.,5.,0.)
      call hbook1(55,'m/pt0 of AJ$',100,0.,2.,0.)
      call hbook1(56,'Delta_R of AJ (gamgam+q)$',100,0.,5.,0.)
      call hbook1(57,'m/pt0 of AJ (gamgam+q)$',100,0.,2.,0.)
      call hbook1(58,'Delta_R of AJ (gamgam+g)$',100,0.,5.,0.)
      call hbook1(59,'m/pt0 of AJ (gamgam+g)$',100,0.,2.,0.)

C  Sum of the cross sections.
      SUMXSEC = 0.0D0
      DO I = 1,NPRUP
         SUMXSEC = XSECUP(i) + SUMXSEC
      ENDDO

      do i=0,3
         evread(i)= 0.d0
         evpos(i)= 0.d0
         evneg(i)= 0.d0
      enddo

C...Event loop.
      DO IEV = 1,NEV

C  Event processing.
C  UPEVNT is called in PYEVNT; then, the PS and decay simulations are done 
C  according the parameter choice.
         CALL PYEVNT
         if( MSTI(51).ne.0 ) then
            print *,'MSTI(51) = ',MSTI(51)
            print *,'-> EOD signal from PYEVNT'
            goto 9000
         endif

         evread(0)= evread(0) +1.d0
         if( IDPRUP.eq.150 .or. IDPRUP.eq.600 ) then
            iproc= 600
            evread(1)= evread(1) +1.d0
         elseif( IDPRUP.eq.151 .or. 
     >           IDPRUP.eq.601 .or. IDPRUP.eq.602 ) then
            if( nporig.ne.5 ) then
               print *,'??? mismatch in the process number ???'
               print *,' nporig = ',nporig
               stop
            endif
            if( kforig(5).ne.21 ) then
               iproc= 601
               evread(2)= evread(2) +1.d0
            else
               iproc= 602
               evread(3)= evread(3) +1.d0
            endif
         else
            print *,'??? Illegal process number ???'
            print *,' IDPRUP = ',IDPRUP
            stop
         endif

         if( IEV.le.2 ) then
            CALL PYLIST(1)
         elseif( IEV.lt.1000 ) then
            if( mod(IEV,100).eq.0 ) print *,'Event# ',IEV
         elseif( IEV.lt.10000 ) then
            if( mod(IEV,1000).eq.0 ) print *,'Event# ',IEV
         else
            if( mod(IEV,10000).eq.0 ) print *,'Event# ',IEV
         endif

C  Document lines.
         ndoc= 0
         ngam0= 0
         do i=1,N
            if( K(i,1).eq.21 ) then
               ndoc= i
               if( K(i,3).eq.0 ) then
                  idabs= iabs( K(i,2) )
                  if( idabs.eq.22 ) then
                     ngam0= ngam0 +1
                     if( ngam0.le.2 ) ipgam0(ngam0)= i
                  endif
               endif
            else
               goto 1
            endif
         enddo
 1       continue
         if( ngam0.ne.2 ) then
            call EUPdump
            CALL PYLIST(1)
            print *,'!!! Number of gammas not equal to 2 !!!'
            print *,'ngam0 = ',ngam0
            stop
         endif

C  Real records.
C  Two methods are provided in the following because the gamma in the 
C  real record sometimes does not point to a gamma in the documentation 
C  lines as the parent; this must be a bug in PYTHIA.
C         ichoice= 1
         ichoice= 2
C-------------------------------------------------------------------
         if( ichoice.eq.1 ) then
         ipgam(1)= 0
         ipgam(2)= 0
         do i=ndoc+1,N
            if( K(i,1).eq.1 .and. K(i,2).eq.22 ) then
               imoth= K(i,3)
               do ig=1,2
                  if( imoth.eq.ipgam0(ig) ) ipgam(ig)= i
               enddo
            endif
         enddo
         if( ipgam(1).lt.1 .or. ipgam(2).lt.1 ) then
            CALL PYLIST(1)
            print *,'??? Corresponding gamma not found in real record',
     >           '???'
            print *,'gammas in doc = ',ipgam0
            stop
         endif
C-------------------------------------------------------------------
         else
         ngam= 0
         do i=ndoc+1,N
            if( K(i,1).eq.1 .and. K(i,2).eq.22 ) then
               imoth= K(i,3)
               if( imoth.le.ndoc ) then
                  ngam= ngam +1
                  if( ngam.le.10 ) ipgam(ngam)= i
               endif
            endif
         enddo
         if( ngam.ne.2 ) then
            if( ngam.lt.2 ) then
               call EUPdump
               CALL PYLIST(1)
               print *,'!!! Number of gammas smaller than 2 !!!'
               print *,'ngam = ',ngam
               stop
            endif
C            print *,'This is likely to be a bug in PYTHIA.'
C            print *,'-> hardest 2 gammas are taken.'
            ptsq1= P(ipgam(1),1)**2 +P(ipgam(1),2)**2
            ptsq2= P(ipgam(2),1)**2 +P(ipgam(2),2)**2
            do i=3,ngam
               ptsq= P(ipgam(i),1)**2 +P(ipgam(i),2)**2
               if( ptsq.gt.ptsq1 .or. ptsq.gt.ptsq2 ) then
                  if( ptsq1.lt.ptsq2 ) then
                     ipgam(1)= ipgam(i)
                     ptsq1= ptsq
                  else
                     ipgam(2)= ipgam(i)
                     ptsq2= ptsq
                  endif
               endif
            enddo
         endif
         endif

C   Kinematical cut.
         do ig=1,2
            do i=1,4
               pgam(i,ig)= P(ipgam(ig),i)
            enddo
         enddo
         call pteta( pgam(1,1), pt1, eta1 )
         call pteta( pgam(1,2), pt2, eta2 )
         if( pt1.le.pt2 ) then
            call hf1(1,real(pt1),1.)
            call hf1(2,real(pt2),1.)
         else
            call hf1(1,real(pt2),1.)
            call hf1(2,real(pt1),1.)
         endif
         call hf1(3,real(eta1),1.)
         call hf1(3,real(eta2),1.)

         if( pt1.lt.ptcut1 .or. pt2.lt.ptcut1 ) goto 9
         if( pt1.lt.ptcut2 .and. pt2.lt.ptcut2 ) goto 9
         if( abs( eta1 ).gt.etacut 
     >        .or. abs( eta2 ).gt.etacut ) goto 9

         csdphi= ( pgam(1,1)*pgam(1,2) +pgam(2,1)*pgam(2,2) )/pt1/pt2
         if( csdphi.gt.1.d0 ) csdphi= 1.d0
         if( csdphi.lt.-1.d0 ) csdphi= -1.d0
         dphiAA= acos( csdphi )
         dRAA= sqrt( dphiAA**2 +( eta1 -eta2 )**2 )
         call hf1(4,real(dRAA),1.)

         if( dRAA.lt.drsepa ) goto 9

         do i=1,4
            pAA(i)= pgam(i,1) +pgam(i,2)
         enddo
         amAA= sqrt( pAA(4)**2 -pAA(3)**2 -pAA(2)**2 -pAA(1)**2 )
         call hf1(5,real(amAA),1.)

         if( amAA.lt.amcut1 .or. amAA.gt.amcut2 ) goto 9

C  Isolation cut.
         etiso(1)= 0.d0
         etiso(2)= 0.d0
         do i=ndoc+1,N
            if( i.ne.ipgam(1) .and. i.ne.ipgam(2) 
     >           .and. K(i,1).eq.1 ) then
               idabs= iabs( K(i,2) )
               if( idabs.ne.12 .and. idabs.ne.14 .and. 
     >              idabs.ne.16 ) then
                  do j=1,4
                     ptest(j)= P(i,j)
                  enddo
                  et= P(i,4)*PYP( i, 10 )/PYP( i, 8 )
                  do ig=1,2
                     dr= delta_r( pgam(1,ig), ptest )
                     if( dr.lt.driso ) then
                        etiso(ig)= etiso(ig) +et
                     endif
                  enddo
               endif
            endif
         enddo
         call hf1(6,real(etiso(1)),1.)
         call hf1(6,real(etiso(2)),1.)

         if( etiso(1).gt.etisocut .or. etiso(2).gt.etisocut ) goto 9

C  Accepted.
         if( XWGTUP.ge.0.d0 ) then
            weight= 1.
            evpos(0)= evpos(0) +1.d0
            if( iproc.eq.600 ) evpos(1)= evpos(1) +1.d0
            if( iproc.eq.601 ) evpos(2)= evpos(2) +1.d0
            if( iproc.eq.602 ) evpos(3)= evpos(3) +1.d0
         else
            weight= -1.
            evneg(0)= evneg(0) +1.d0
            if( iproc.eq.600 ) evneg(1)= evneg(1) +1.d0
            if( iproc.eq.601 ) evneg(2)= evneg(2) +1.d0
            if( iproc.eq.602 ) evneg(3)= evneg(3) +1.d0
         endif

C  Selected events.
         ptAA= sqrt( pAA(1)**2 +pAA(2)**2 )
         rapAA= log( ( pAA(4) +pAA(3) )/( pAA(4) -pAA(3) ) )/2.d0

         if( pt1.le.pt2 ) then
            call hf1(10,real(pt1),1.)
            call hf1(11,real(pt2),1.)
         else
            call hf1(10,real(pt2),1.)
            call hf1(11,real(pt1),1.)
         endif
         call hf1(12,real(eta1),1.)
         call hf1(12,real(eta2),1.)
         call hf1(13,real(dRAA),1.)
         call hf1(14,real(amAA),1.)
         call hf1(15,real(ptAA),1.)
         call hf1(16,real(rapAA),1.)
         call hf1(17,real(dphiAA),1.)

         if( pt1.le.pt2 ) then
            call hf1(20,real(pt1),weight)
            call hf1(21,real(pt2),weight)
         else
            call hf1(20,real(pt2),weight)
            call hf1(21,real(pt1),weight)
         endif
         call hf1(22,real(eta1),weight)
         call hf1(22,real(eta2),weight)
         call hf1(23,real(dRAA),weight)
         call hf1(24,real(amAA),weight)
         call hf1(25,real(ptAA),weight)
         call hf1(26,real(rapAA),weight)
         call hf1(27,real(dphiAA),weight)

         if( iproc.eq.600 ) then
            call hf1(30,real(ptAA),weight)
            call hf1(31,real(dphiAA),weight)
         elseif( iproc.eq.601 ) then
            call hf1(32,real(ptAA),weight)
            call hf1(33,real(dphiAA),weight)
         elseif( iproc.eq.602 ) then
            call hf1(34,real(ptAA),weight)
            call hf1(35,real(dphiAA),weight)
         endif

C  Check the input data.
         nglha= 0
         iplha1= 0
         iplha2= 0
         do i=1,NUP
            if( ISTUP(i).eq.1 .and. IDUP(i).eq.22 ) then
               nglha= nglha +1
               if( nglha.eq.1 ) iplha1= i
               if( nglha.eq.2 ) iplha2= i
            endif
         enddo
         if( nglha.ne.2 ) then
            call EUPdump
            print *,'Num. of photons is not 2 in the LHA interface.'
            print *,'nglha = ',nglha
            stop
         endif

         call pteta( PUP(1,iplha1), ptlha1, etalha1 )
         call pteta( PUP(1,iplha2), ptlha2, etalha2 )
         dRlha= delta_r( PUP(1,iplha1), PUP(1,iplha2) )

         if( ptlha1.le.ptlha2 ) then
            call hf1(40,real(ptlha1),1.)
            call hf1(41,real(ptlha2),1.)
         else
            call hf1(40,real(ptlha2),1.)
            call hf1(41,real(ptlha1),1.)
         endif
         call hf1(42,real(etalha1),1.)
         call hf1(42,real(etalha2),1.)
         call hf1(43,real(dRlha),1.)

C  Check the original hard interaction information.
         call pteta( porig(1,3), ptorig1, etaorig1 )
         call pteta( porig(1,4), ptorig2, etaorig2 )
         dRorig= delta_r( porig(1,3), porig(1,4) )

         if( ptorig1.le.ptorig2 ) then
            call hf1(50,real(ptorig1),1.)
            call hf1(51,real(ptorig2),1.)
         else
            call hf1(50,real(ptorig2),1.)
            call hf1(51,real(ptorig1),1.)
         endif
         call hf1(52,real(etaorig1),1.)
         call hf1(52,real(etaorig2),1.)
         call hf1(53,real(dRorig),1.)

         if( iproc.eq.601 .or. iproc.eq.602 ) then
            dr1= delta_r( porig(1,3), porig(1,5) )
            dr2= delta_r( porig(1,4), porig(1,5) )
            if( dr1.le.dr2 ) then
               drAJ= dr1
            else
               drAJ= dr2
            endif
            am1= sqrt( ( porig(4,3) +porig(4,5) )**2
     >           -( porig(3,3) +porig(3,5) )**2
     >           -( porig(2,3) +porig(2,5) )**2
     >           -( porig(1,3) +porig(1,5) )**2 )
            am2= sqrt( ( porig(4,4) +porig(4,5) )**2
     >           -( porig(3,4) +porig(3,5) )**2
     >           -( porig(2,4) +porig(2,5) )**2
     >           -( porig(1,4) +porig(1,5) )**2 )
            if( am1.le.am2 ) then
               amAJ= am1
               rmAJ= amAJ/ptorig2
            else
               amAJ= am2
               rmAJ= amAJ/ptorig1
            endif
            call hf1(54,real(drAJ),weight)
            call hf1(55,real(rmAJ),weight)
            if( iproc.eq.601 ) then
               call hf1(56,real(drAJ),weight)
               call hf1(57,real(rmAJ),weight)
            else
               call hf1(58,real(drAJ),weight)
               call hf1(59,real(rmAJ),weight)
            endif
         endif

C...End of loop over events.
 9       continue
      ENDDO

 9000 continue
      WRITE(*,'(/'' ########## Analysis completed ##########'')')
      print '('' Integrated absolute cross section = '',E12.6,
     >     '' pb'')', SUMXSEC
      lun= 30
      open(lun,file='../generation.txt',form='FORMATTED',
     >     status='OLD')
      read(lun,'(F10.0)') evgen
      read(lun,'(F10.0)') evwrt
      close(lun)
      print '(F10.0,'' events generated'')',evgen
      print '(F10.0,'' events written in the input file'')',evwrt
      evgen= evgen*evread(0)/evwrt
      print *,'Renormalize to the number of events actually analysed.'
      print '('' -> '',E12.5,'' events at the generation'')',evgen
      print '('' ----------------------------------------'')'
      do i=0,3
         if( i.eq.0 ) then
            print *,'Total'
         elseif( i.eq.1 ) then
            print *,'gamma-gamma'
         elseif( i.eq.2 ) then
            print *,'gamma-gamma + q'
         else
            print *,'gamma-gamma + g'
         endif
         evtot= evpos(i) +evneg(i)
         print '(F10.0,'' events accepted out of '',F10.0,'' events'')',
     >        evtot,evread(i)
         eff= evtot/evread(i)
         efferr= sqrt( eff*( 1.d0 -eff )/evread(i) )
         print '('' efficiency = '',F6.4,'' +- '',F6.4)',eff,efferr
         frac= evtot/evgen
         xabs= SUMXSEC * frac
         xabserr= SUMXSEC*sqrt( frac*( 1.d0 -frac )/evgen )
         print '('' -> abs. xsec = '',E12.4,'' +- '',E10.4,'' pb'')',
     >        xabs,xabserr
         print '(F10.0,'' positive, and '',F10.0,
     >        '' negative weight events'')', evpos(i),evneg(i)
         rneg= evneg(i)/evtot
         rnegerr= sqrt( rneg*( 1.d0 -rneg )/evtot )
         print '('' Negative weight fraction = '',F10.6,
     >        '' +- '',F10.6)', rneg,rnegerr
         efftot= evtot/evgen
         evdif= evpos(i) -evneg(i)
         pnasym= evdif/evtot
         xsec= SUMXSEC * efftot * pnasym
         xsecerr= xsec * sqrt( ( 1. -efftot )/efftot/evgen
     >        +( 1. -pnasym )/pnasym/evtot )
         print '('' True cross section = '',E12.6,'' +-'',E10.4,
     >        '' pb'')', xsec,xsecerr
         print '('' ----------------------------------------'')'
      enddo
      print *,'Cross section errors do not include the error in BASES.'
      print *,''

C...Cross section table.
      CALL PYSTAT(1)

C...Histograms.
      call histdo
C
C -- Store histograms.
C
      if( flhist(1:1).NE.'*' ) then
        call hrput(0,flhist,'N')
      endif

      stop
      END

      subroutine pteta( p, pt, eta )
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      real*8 p(3)

      pt2= p(1)**2 +p(2)**2
      pabs= sqrt( pt2 +p(3)**2 )
      pt= sqrt( pt2 )
      eta= log( ( pabs +abs( p(3) ) )/pt )
      if( p(3).lt.0.d0 ) eta= -eta

      return
      end

      real*8 function delta_r( p1, p2 )
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      real*8 p1(4),p2(4)

      call pteta( p1, pt1, eta1 )
      call pteta( p2, pt2, eta2 )
      csphi= ( p1(1)*p2(1) +p1(2)*p2(2) )/pt1/pt2
      if( csphi.gt.1.d0 ) csphi= 1.d0
      if( csphi.lt.-1.d0 ) csphi= -1.d0
      dphi= acos( csphi )
      delta_r= sqrt( dphi**2 +( eta1 -eta2 )**2 )

      return
      end

      SUBROUTINE UPINIT
C  An "LhaExt" version of UPINIT.
C
C  This routine opens a data file, reads in the "run information" from the 
C  header records, and skips siecified number of events.
C  LUNs for the control file and the data file, and other control parameters 
C  must be given in a read-control file named "lharead_control.txt".
C
C  June 8, 2004, S. Odaka (KEK)
      IMPLICIT NONE

      integer lunctl,lundat,ifmt
      common /lharead/lunctl,lundat,ifmt

      character*80 lhactl
      parameter ( lhactl= 'lharead_control.txt' )
      integer lun,idwt,nSkip,iev
      integer lun1,lun2

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

      print *,' '
      print *,'============================== UPINIT =====',
     >     '=================================='

C  Open the control file.
      lun= 10
      call lunfind( lun )
      lunctl= lun
      open(lunctl,file=lhactl,status='OLD')
      print '('' LHA control file opened: LUN = '',I3)',lunctl
      print '(''   file name = '',A80)',lhactl

C  Read the 1st line: LUNs for the control file and the data file.
      read(lunctl,*) lun1,lun2
      if( lun1.ge.1 ) then
         close( lunctl )
         lunctl= lun1
         print '('' LUN for the control file reassigned: LUN = '',
     >        I3)',lunctl
         open(lunctl,file=lhactl,status='OLD')
         read(lunctl,*) lun1
      endif

C  Read the 2nd line: the parameter for the weighting strategy.
      read(lunctl,*) idwt
      print '('' Specified weighting strategy = '',I3)',idwt
      if( idwt.eq.0 ) then
         print *,'   -> no overwrite'
      else
         print *,'   -> overwrite'
      endif

C  Read the 3rd line: number of events to skip.
      read(lunctl,*) nSkip
      print '('' First '',I3,'' events will be skipped.'')',nSkip

C  Open the 1st data file.
      if( lun2.ge.1 ) then
         lundat= lun2
      else
         call lunfind( lun )
         lundat= lun
      endif
      print '('' Input data file: LUN = '',I3)',lundat

      call lhaopen( lunctl, lundat, ifmt, *9 )

C  Update the run information.
      print *,'Read the header record'
      if( ifmt.eq.0 ) then
         call lhaReadHdAsc( lundat, 0 )
      elseif( ifmt.eq.1 ) then
         call lhaReadHdBin( lundat, 0 )
      endif

C  Overwrite the weighting strategy parameter if specified.
      if( idwt.ne.0 ) IDWTUP= idwt
      print '('' -> weighting strategy = '',I3)',IDWTUP

C  Skip specified number of events.
      if( nSkip.gt.0 ) then
         do iev=1,nSkip
            call lhaReadEvnt(lunctl,lundat,ifmt,*8)
         enddo
         print '('' First '',I3,'' events skipped.'')',nSkip
      endif

      print *,'===========================================',
     >     '=================================='

      return

 8    continue
      print *,'End-of-data during the event skip -> stop'
      stop

 9    continue
      print *,'(error) no input-data file given'
      stop

      end

      subroutine lunfind( lun )
      integer lun
      logical lopen

 1    inquire( lun, opened=lopen )
      if( lopen ) then
         lun= lun +1
         goto 1
      endif

      return
      end

      subroutine lhaopen( lunctl, lundat, ifmt, * )

      character*10 filefmt
      character*80 filename

C  Read the information for the 1st data file.
      call lhactlrd( lunctl, filefmt, filename, *9 )
      print '('' New input file: format = '',A10)',filefmt
      print '(''   file name = '',A80)',filename

C  Open the 1st data file.
      if( filefmt(1:3).eq.'asc' ) then
         ifmt= 0
         open(lundat,file=filename,form='FORMATTED',status='OLD')
      elseif( filefmt(1:3).eq.'bin' ) then
         ifmt= 1
         open(lundat,file=filename,form='UNFORMATTED',status='OLD')
      endif

      print *,'   -> successfully opened'

      return

 9    return 1

      end

      subroutine lhactlrd( lunctl, filefmt, filename, * )

      character*10 filefmt
      character*80 filename
      character*80 string

 1    read(lunctl,'(A80)',end=9) string
C      print *,'Input string:'
C      print '(A80)',string

      if( string(1:1).eq.'*' ) goto 1
      if( string(1:4).eq.'end ' .or. string(1:4).eq.'End '
     >     .or. string(1:4).eq.'END ' ) goto 9

      isep= 0
      do i=1,80
         isep= isep +1
         if( string(isep:isep).eq.':' ) goto 2
      enddo
      print *,'LHACTLRD (error): no separator in the control list'
      stop

 2    continue
      filefmt= string(1:isep-1)
      filename= string(isep+1:80)

      return

 9    continue
      print *,'LHACTLRD: end of the control list'
      return 1

      end

      SUBROUTINE UPEVNT
C  An "LhaExt" version of UPEVNT.
C
C  This routine reads in one event from a data file.
C  The actual read action is done by "lhaReadEvnt".
C  The end-of-data of the input is signaled to the calling routine by
C  setting NUP = 0.
C
C  June 8, 2004, S. Odaka (KEK)
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

      integer lunctl,lundat,ifmt
      common /lharead/lunctl,lundat,ifmt

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

C  Original hard interaction information.
      integer nporig,iprorig,kforig
      real*8 porig
      common /info_orig/nporig,iprorig,kforig(10),porig(5,10)

C  Read an event record.
 1    continue
      call lhaReadEvnt(lunctl,lundat,ifmt,*9)

C  Move the added info to a separate arrays.
      iprorig= IDPRUP
      nporig= 0
      do i=1,NUP
         if( ISTUP(i).ge.100 ) then
            nporig= nporig +1
            kforig(nporig)= IDUP(i)
            ISTUP(i)= 0
            IDUP(i)= 0
            do j=1,5
               porig(j,nporig)= PUP(j,i)
               PUP(j,i)= 0.d0
            enddo
         endif
      enddo
      NUP= NUP -nporig
      if( NUP.gt.80 ) then
         print *,'Skip an event because too many particles read: ',
     >        'NUP= ',NUP
         goto 1
      endif

      return

C  No more file to read.
 9    continue
      NUP= 0
      return

      END
