C    _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
C   _/_/  Subprocess function   _/_/
C  _/_/  Date   06/04/2002     _/_/
C _/_/  Author Soushi Tsuno   _/_/
C_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
      function fnc614(x)
      implicit real*8(a-h,o-z)
      real*8   fnc614

#include "define.h"

      include 'incl6141.h'
      include 'inclk.h'
      include 'grchad.inc'

      parameter ( mxdim = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     $     IG(MXDIM),NCALL

      real*8 ansm, ans
      real*8 x(mxdim),ytmp,ajacob
      external drn

C+------------------------------------------------+
#ifdef VBASESMPI
      include 'inclvs.f'
      real*8  xv(nsize, mxdim),ansv(nsize)
      common /vbhdat/ xv,ansv
      common /vbhcnt/ isamp
#endif
C+------------------------------------------------+

      if (igsub.gt.300.and.ibsint.lt.2) then
C...Set Parameter for kinematics
         call grcikin
C...Integration/Event Generation : 1/0
         do i = 1, ndim
            xrun(i) = x(i)
         enddo
      else
         igsub = 614
      endif

C...Set particle combination
      call grcspid
C...Set Particle Masses
      call setmas
C...Set Process
      call g614finit
C...Set Kinematic Variables
      call grcsval

      if (irej.gt.0) then
         if (ibsint.eq.1) inkv = inkv + 1
         go to 999
      endif

C...Set Flavor from Proton/Anti-Proton
      call grcprtnqq
C...Fill Kinematics
      ajacob = 0.0d0
      call grcskin(pgrc,ajacob)
      yacob = yacob*ajacob
C...Set Coupling constant
      call grcsene
C...Set Vertex
      call a614mclr
      call amparm

      ansum = 0.0d0
      dft   = 0.0d0
      ytmp = yacob

C...Loop over Each Phase Space if necessary
      do 1000 ireg = 1 , mxreg
         yacob = ytmp

C...Set User Defined Function
         call grcusrfnc614(ireg)
C...Apply Kinematical Cuts
         call grcscut
         if (irej.gt.0) go to 1000

         do 20 i = 1, 4
            pe6141(i) = pgrc(i, kperm(1))
            pe6142(i) = pgrc(i, kperm(2))
            pe6143(i) = pgrc(i, kperm(3))
            pe6144(i) = pgrc(i, kperm(4))
            pe6145(i) = pgrc(i, kperm(5))
 20      continue

C...Set Invariants
         do i=1,5
            do j=1,5
               prod(i,j) = pgrc(4,i)*pgrc(4,j) 
     $              - pgrc(1,i)*pgrc(1,j) 
     $              - pgrc(2,i)*pgrc(2,j) 
     $              - pgrc(3,i)*pgrc(3,j)
            enddo
         enddo

C...Calculate Matrix Elements
         call a614kptbl
         call a614mptbl
         call a614mpsum(ansm)
         ansm= ansm*aspin

C  LLL subtraction.
         if( matching.eq.1 ) then
            call lll_a2j( igsub, anslll, iret )
            if( iret.eq.0 ) then
               ansm= ansm -anslll
            else
               ansm= 0.d0
               goto 999
            endif
         endif

         ans    = ansm*yacob/aident

C  Return the absolute value to BASES/SPRING.
C  The signed result is separately stored.
         signedres= ans
         ans= abs( ans )

         ansum  = ansum + ans

C...Store Color String Information
         if (ibsint.eq.2) then
            grcdsig(ireg) = ans
            call sp614detc(ireg)
            call sp614deth(ireg)
         endif
 1000 continue

C...Set Value of Function
      fnc614 = ansum

C...Check Integration
      if (ibsint.eq.1) then
         inbs = inbs + 1
         if (mod(inbs,nfprt).eq.0) then
            write(*,*) inbs
         endif

         if (irej.eq.2) inkc = inkc + 1
         if (irej.eq.3) in4m = in4m + 1
         if (irej.eq.4) inac = inac + 1

         funcmax = max(funcmax,fnc614)

C+------------------------------------------------+
#ifndef VBASESMPI
         do i = 1, ndim
            call xhfill(i,x(i),fnc614)
         enddo
#endif
C+------------------------------------------------+

C+------------------------------------------------+
#ifdef VBASESMPI
         do i = 1, ndim
            xv(isamp,i) = x(i)
         enddo
         ansv(isamp) = fnc614
#endif
C+------------------------------------------------+

         if (funcmax.le.fnc614) then
         endif
      endif

      return
 999  continue
      yacob = 0.0d0
      fnc614 = 0.0d0
      return
      end
