      subroutine me612( kfgen, p, ans, iret )
C  Calculate the matrix element of the process 612: u g -> A + u g.
C  iret = 0 if reasonablly evaluated.
      implicit real*8(a-h,o-z)
      include 'incl6121.h'
      include 'inclk.h'

      parameter ( nextrn= 5, nextrn0= nextrn -1 )
      integer kfgen(nextrn)
      real*8 p(4,nextrn)
      real*8 bdir(3),ptemp(4),p0(4,nextrn0)

C  Return with non-zero "iret" if a soft radiation is found.
      ans= 0.d0
      iret= 1

      do irad=4,nextrn
         do imoth=1,2
            nonrad= 0
            if( irad.eq.4 .and. imoth.eq.2 ) nonrad= 611
            if( irad.eq.5 ) nonrad= 610
            if( nonrad.gt.0 ) then
               do i=1,4
                  ptemp(i)= p(i,imoth) -p(i,irad)
               enddo
               qsq= ptemp(1)**2 +ptemp(2)**2 +ptemp(3)**2 -ptemp(4)**2
               if( imoth.eq.1 ) then
                  call bstcm( ptemp, p(1,2),
     >                 pcm, ecm1, ecm2, bdir, gamma, phi, theta )
               else
                  call bstcm( p(1,1), ptemp,
     >                 pcm, ecm1, ecm2, bdir, gamma, phi, theta )
               endif
               pini= ( ecm1 +ecm2 )/2.d0
               p0(1,1)= 0.d0
               p0(2,1)= 0.d0
               p0(3,1)= pini
               p0(4,1)= pini
               p0(1,2)= 0.d0
               p0(2,2)= 0.d0
               p0(3,2)= -pini
               p0(4,2)= pini
               j= 2
               do i=3,nextrn
                  if( i.ne.irad ) then
                     j= j +1
                     call bstfw( p(1,i), bdir, gamma, phi, theta,
     >                    p0(1,j) )
                  endif
               enddo
               call setscale( nonrad, p0, qren, qfac )
               if( qsq.lt.qfac**2 ) return
            endif
         enddo
      enddo

      do ip1=3,nextrn-1
         do ip2=ip1+1,nextrn
            nonrad= 0
            if( ip1.eq.3 .and. ip2.eq.4 ) then
               nonrad= 305
               ichild= 4
               irad= 3
            endif
            if( ip1.eq.4 .and. ip2.eq.5 ) then
               nonrad= 610
               ichild= 4
               irad= 5
            endif
            if( nonrad.gt.0 ) then
               do i=1,4
                  ptemp(i)= p(i,ip1) +p(i,ip2)
               enddo
               psum= sqrt( ptemp(1)**2 +ptemp(2)**2 +ptemp(3)**2 )
               esum= ptemp(4)
               qsq= esum**2 -psum**2
               etot= psum
               do ip=3,nextrn
                  if( ip.ne.ip1 .and. ip.ne.ip2 ) then
                     etot= etot +p(4,ip)
                  endif
               enddo
               pini= etot/2.d0
               p0(1,1)= 0.d0
               p0(2,1)= 0.d0
               p0(3,1)= pini
               p0(4,1)= pini
               p0(1,2)= 0.d0
               p0(2,2)= 0.d0
               p0(3,2)= -pini
               p0(4,2)= pini
               jp= 2
               do ip=3,nextrn
                  if( ip.ne.irad ) then
                     jp= jp +1
                     if( ip.eq.ichild ) then
                        do i=1,3
                           p0(i,jp)= ptemp(i)
                        enddo
                        p0(4,jp)= psum
                     else
                        do i=1,4
                           p0(i,jp)= p(i,ip)
                        enddo
                     endif
                  endif
               enddo
               call scale_fsub( nonrad, p0, qmax )
               if( qsq.lt.qmax**2 ) return
            endif
         enddo
      enddo

C  The radiation is hard enough.
      call g612finit
      call a612mclr
C      call amparm

      do i=1,nextrn
         kfcode(i)= kfgen(i)
      enddo

      ireg= 1
      call grcusrfnc612(ireg)

      do i=1,4
         pe6121(i) = p(i,1)
         pe6122(i) = p(i,2)
         pe6123(i) = p(i,3)
         pe6124(i) = p(i,4)
         pe6125(i) = p(i,5)
      enddo

      do i=1,nextrn
         do j=1,nextrn
            prod(i,j) = p(4,i)*p(4,j) -p(1,i)*p(1,j) 
     >           - p(2,i)*p(2,j) -p(3,i)*p(3,j)
         enddo
      enddo

      do i=1,nextrn
         amass2(i)= p(4,i)**2 -p(3,i)**2 -p(2,i)**2 -p(1,i)**2
         if( amass2(i).lt.0.d0 ) amass2(i)= 0.d0
         amass1(i)= sqrt( amass2(i) )
      enddo

      call a612kptbl
      call a612mptbl
      call a612mpsum( ansm )
      ans= ansm*aspin

      iret= 0

      return
      end
