      program grappa
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INCLUDE 'inclk.h'
      INCLUDE 'grchad.inc'

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

      EXTERNAL DRN
      INTEGER IEV,IDUMMY,IGSEC
      DOUBLE PRECISION SUMXSEC,CRAN

C  PS info
      COMMON/QPLIST/PLPTN(10,10000),NLPTN(10,10000),NTOP
      common/QPinfo/Qps,ipps(3,2)

C  PSKINI information
      common/PSKfail/ ifail_pskini,nfail_pskini

C...Statement to link the block data; comment out if any trouble.
C      EXTERNAL GRCBLOCKD

      character*80 lhafile
      parameter ( lhcom = 100000 )
      real*4 h
      common /pawc/h(lhcom)
      character*72 flhist
      real*4 weight

C------------------------------------------------------------------
      real*8 pprom(4),pfrag(4),pAA(4)

      dimension bdir(3)
      dimension pprom0(4),pfrag0(4),prem0(4)
      dimension pjet0(4)
      logical addgen/.false./

C-----------------------------------------------------------------------
C  Add the parton-level "gam gam + jet" info. to the LHA event file.
C  Turn off unless the read routine can handle this info. properly.
C-----------------------------------------------------------------------
      addgen= .true.
C-----------------------------------------------------------------------
C  Output hbook file; "*" for no output.
C-----------------------------------------------------------------------
C      flhist= '*'
      flhist= 'hist.hbook'
C-----------------------------------------------------------------------
C  Number of events to generate.
C-----------------------------------------------------------------------
      nevent= 10000
C-----------------------------------------------------------------------
C  Logical unit number for the output event file; 0 for no output.
C-----------------------------------------------------------------------
C      lunwrit= 0
      lunwrit= 20
C-----------------------------------------------------------------------
      if( lunwrit.gt.0 ) then
C  (ASCII file)
         ifmt= 0
         lhafile= 'lhaext_a1j_frag_asc.dat'
         open(lunwrit,file=lhafile,form='FORMATTED',status='NEW')
C  (binary file)
C         ifmt= 1
C         lhafile= 'lhaext_bin.dat'
C         open(lunwrit,file=lhafile,form='UNFORMATTED',status='NEW')
C  (LHA event file)
C         ifmt= 2
C         lhafile= 'lhaext.lhe'
C         open(lunwrit,file=lhafile,form='FORMATTED',status='NEW')
      endif
C-----------------------------------------------------------------------
C  Book histograms.
C-----------------------------------------------------------------------
      call hlimit(lhcom)

      call hbook1(1,'num. of gammas$',20,0.,20.,0.)
      call hbook1(2,'num. of FSR jets$',50,0.,50.,0.)
      call hbook1(3,'eta of prompt gam$',100,-5.,5.,0.)
      call hbook1(4,'pt of prompt gam$',100,0.,200.,0.)
      call hbook1(5,'eta of frag gam$',100,-5.,5.,0.)
      call hbook1(6,'pt of frag gam$',100,0.,200.,0.)
      call hbook1(7,'pt of larger-pt gam$',100,0.,200.,0.)

      call hbook1(10,'Delta-R of AA$',100,0.,5.,0.)
      call hbook1(11,'mass of AA$',100,0.,200.,0.)
      call hbook1(12,'pt of AA$',100,0.,200.,0.)
      call hbook1(13,'rapidity of AA$',100,-5.,5.,0.)
      call hbook1(14,'Delta-phi of AA$',20,0.,3.1416,0.)

      call hbook1(20,'eta of prompt gam (gen)$',100,-5.,5.,0.)
      call hbook1(21,'pt of prompt gam (gen)$',100,0.,100.,0.)
      call hbook1(22,'eta of jet (gen)$',100,-5.,5.,0.)
      call hbook1(23,'pt of jet (gen)$',100,0.,100.,0.)
C-----------------------------------------------------------------------
C...Initialization.
      CALL UPINIT
      call RUPdump

C  Output the header data.
      if( lunwrit.gt.0 ) then
         if( ifmt.eq.0 ) then
            call lhaWritHdAsc(lunwrit)
         elseif( ifmt.eq.1 ) then
            call lhaWritHdBin(lunwrit)
         elseif( ifmt.eq.2 ) then
            call lhaWritHdLhef(lunwrit)
         endif
      endif

C  Sum of the cross sections.
      SUMXSEC = 0.0D0
      DO I = 1,NPRUP
         SUMXSEC = XSECUP(i) + SUMXSEC
      ENDDO

C...Event loop.
      WRITE(*,'(/10X,''########## Start generating events ##########''
     >     )')

      iprint= 0

      DO IEV = 1,nevent

C...Event generation.

C  Process selection.
         CRAN = DRN(IDUMMY)*SUMXSEC
         IGSEC = 0
         DO WHILE (CRAN.GT.0.0D0)
            IGSEC = IGSEC + 1
            CRAN = CRAN - XSECUP(IGSEC)
         ENDDO
         IDPRUP = LPRUP(IGSEC)

C  Generation
         CALL UPEVNT

         IF (IEV.LE.2) THEN
            WRITE(*,*) ' '
            WRITE(*,*) 'Event# ',IEV
            call EUPdump
         elseif( iev.le.1000 ) then
            if( mod( iev, 100 ).eq.0 ) WRITE(*,*) 'Event# ',IEV
         elseif( iev.le.10000 ) then
            if( mod( iev, 1000 ).eq.0 ) WRITE(*,*) 'Event# ',IEV
         else
            if( mod( iev, 10000 ).eq.0 ) WRITE(*,*) 'Event# ',IEV
         ENDIF

C  Selection
         ngam= 0
         ipprom= 0
         ipfrag= 0
         ptfrag= 0.d0
         njet= 0
         do i=1,NUP
            if( IDUP(i).eq.22 ) then
               ngam= ngam +1
               if( ngam.eq.1 ) then
                  ipprom= i
               else
                  call pteta( PUP(1,i), pt, eta )
                  if( pt.gt.ptfrag ) then
                     ipfrag= i
                     ptfrag= pt
                     etafrag= eta
                  endif
               endif
            elseif( MOTHUP(1,i).eq.1 .and. MOTHUP(2,i).eq.2 .and.
     >              ( iabs( IDUP(i) ).le.5 .or. IDUP(i).eq.21 ) ) then
               njet= njet +1
            endif
         enddo
         if( ngam.lt.2 ) then
            print *,'Num. of gammas smaller than 2.'
            stop
         endif

         call hf1(1,ngam+.5,1.)
         call hf1(2,njet+.5,1.)

         call pteta( PUP(1,ipprom), ptprom, etaprom )
         call hf1(3,real(etaprom),1.)
         call hf1(4,real(ptprom),1.)

         call hf1(5,real(etafrag),1.)
         call hf1(6,real(ptfrag),1.)

         if( ptprom.ge.ptfrag ) then
            ptlarg= ptprom
         else
            ptlarg= ptfrag
         endif
         call hf1(7,real(ptlarg),1.)

         drAA= delta_r( PUP(1,ipprom), PUP(1,ipfrag) )
         call hf1(10,real(drAA),1.)

         do i=1,4
            pprom(i)= PUP(i,ipprom)
            pfrag(i)= PUP(i,ipfrag)
            pAA(i)= pprom(i) +pfrag(i)
         enddo
         amAA= sqrt( pAA(4)**2 -pAA(3)**2 -pAA(2)**2 -pAA(1)**2 )
         call hf1(11,real(amAA),1.)

         ptAA= sqrt( pAA(1)**2 +pAA(2)**2 )
         rapAA= log( ( pAA(4) +pAA(3) )/( pAA(4) -pAA(3) ) )/2.d0
         csdphi= ( pprom(1)*pfrag(1) +pprom(2)*pfrag(2) )/ptprom/ptfrag
         if( csdphi.gt.1.d0 ) csdphi= 1.d0
         if( csdphi.lt.-1.d0 ) csdphi= -1.d0
         dphiAA= acos( csdphi )

         call hf1(12,real(ptAA),1.)
         call hf1(13,real(rapAA),1.)
         call hf1(14,real(dphiAA),1.)

C  Add the generation info. to the LHA interface.
         if( addgen ) then

C  Pointers to the initial-state partons in the PS array initiated the hard 
C  interaction.
            ipsini1= ipps(2,1)
            ipsini2= ipps(2,2)
            call bstcm( PLPTN(4,ipsini1), PLPTN(4,ipsini2),
     >           pcm, e1, e2, bdir, gamma, phi, theta )
            ecmini= e1 +e2
            idini1= NLPTN(1,ipsini1)
            idini2= NLPTN(1,ipsini2)
            amini1= ptnmas( idini1 )
            amini2= ptnmas( idini2 )

C  Find the final-state information in the PS array.
            ipsprom= 0
            ipsfrag= 0
            ipsjet= 0
            nfrag= 0
            ptfrag= 0.d0
            do ips=ipsini2+1,NTOP
               if( NLPTN(1,ips).eq.22  ) then
                  if( NLPTN(5,ips).eq.10 ) then
                     ipsprom= ips
                  elseif( NLPTN(5,ips).eq.5 ) then
                     nfrag= nfrag +1
                     pt= sqrt( PLPTN(4,ips)**2 +PLPTN(5,ips)**2 )
                     if( pt.gt.ptfrag ) then
                        ptfrag= pt
                        ipsfrag= ips
                     endif
                  endif
               elseif( NLPTN(5,ips).eq.11 ) then
                  ipsjet= ips
               endif
            enddo
            if( ipsprom.lt.1 .or. ipsfrag.lt.1 .or. ipsjet.lt.1 ) then
               call QPDUMP
               print *,'Illegal PS array:'
               if( ipsprom.lt.1 ) print *,'  prompt photon not found.'
               if( ipsfrag.lt.1 ) print *,'  frag photon not found.'
               if( ipsjet.lt.1 ) print *,'  jet not found.'
               stop
            endif

            ecmfin= sqrt( ( PLPTN(7,ipsprom) +PLPTN(7,ipsjet) )**2
     >           -( PLPTN(6,ipsprom) +PLPTN(6,ipsjet) )**2
     >           -( PLPTN(5,ipsprom) +PLPTN(5,ipsjet) )**2
     >           -( PLPTN(4,ipsprom) +PLPTN(4,ipsjet) )**2 )

C  Correction in "psfbst".
            psinisq= ( PLPTN(4,ipsini1) +PLPTN(4,ipsini2) )**2
     >           +( PLPTN(5,ipsini1) +PLPTN(5,ipsini2) )**2
     >           +( PLPTN(6,ipsini1) +PLPTN(6,ipsini2) )**2

            pxfin= 0.
            pyfin= 0.
            pzfin= 0.
            efin= 0.
            istart= ipsprom
            if( ipsjet.lt.istart ) istart= ipsjet
            do ips=istart,NTOP
               if( NLPTN(3,ips).eq.0 ) then
                  pxfin= pxfin +PLPTN(4,ips)
                  pyfin= pyfin +PLPTN(5,ips)
                  pzfin= pzfin +PLPTN(6,ips)
                  efin= efin +PLPTN(7,ips)
               endif
            enddo
            sfin= efin**2 -pzfin**2 -pyfin**2 -pxfin**2

            gamma= sqrt( psinisq/sfin +1.d0 )

C  Boost to the CM frame to define the remnant jet momentum.
            call bstfw( pprom, bdir, gamma, phi, theta, pprom0 )
            call bstfw( pfrag, bdir, gamma, phi, theta, pfrag0 )
            do i=1,3
               prem0(i)= -pprom0(i) -pfrag0(i)
            enddo
            idrem= NLPTN(1,ipsjet)
            amrem= ptnmas( idrem )
            prem0(4)= sqrt( prem0(1)**2 +prem0(2)**2 +prem0(3)**2
     >           +amrem**2 )

C  On-shell momentum of the initial partons.
            shat= ecmfin**2
            amsq1= amini1**2
            amsq2= amini2**2
            pinisq= ( ( shat -amsq1 -amsq2 )**2/4.d0 -amsq1*amsq2 )/shat
            pini= sqrt( pinisq )

C  Lorentz parameters of the ideal lab. frame.
            betlab= ( GPRI(5) -GPRI(6) )/( GPRI(5) +GPRI(6) )
            gamlab= sqrt( 1.d0/( 1.d0 -betlab**2 ) )

C  Fill the LHA array.
            ip= NUP

C  (initial-state partons)
            ip= ip +1
            pz= pini
            ene= sqrt( pini**2 +amsq1 )
            IDUP(ip)= idini1
            ISTUP(ip)= 100
            PUP(1,ip) = 0.d0
            PUP(2,ip) = 0.d0
            PUP(3,ip) = gamlab*( pz +betlab*ene )
            PUP(4,ip) = gamlab*( betlab*pz +ene )
            PUP(5,ip) = amini1

            ip= ip +1
            pz= -pini
            ene= sqrt( pini**2 +amsq2 )
            IDUP(ip)= idini2
            ISTUP(ip)= 100
            PUP(1,ip) = 0.d0
            PUP(2,ip) = 0.d0
            PUP(3,ip) = gamlab*( pz +betlab*ene )
            PUP(4,ip) = gamlab*( betlab*pz +ene )
            PUP(5,ip) = amini2

C  (prompt photon)
            ip= ip +1
            IDUP(ip)= 22
            ISTUP(ip)= 100
            PUP(1,ip) = pprom0(1)
            PUP(2,ip) = pprom0(2)
            PUP(3,ip) = gamlab*( pprom0(3) +betlab*pprom0(4) )
            PUP(4,ip) = gamlab*( betlab*pprom0(3) +pprom0(4) )
            PUP(5,ip) = 0.d0

C  (fragment photon)
            ip= ip +1
            IDUP(ip)= 22
            ISTUP(ip)= 100
            PUP(1,ip) = pfrag0(1)
            PUP(2,ip) = pfrag0(2)
            PUP(3,ip) = gamlab*( pfrag0(3) +betlab*pfrag0(4) )
            PUP(4,ip) = gamlab*( betlab*pfrag0(3) +pfrag0(4) )
            PUP(5,ip) = 0.d0

C  (remnant jet)
            ip= ip +1
            IDUP(ip)= idrem
            ISTUP(ip)= 100
            PUP(1,ip) = prem0(1)
            PUP(2,ip) = prem0(2)
            PUP(3,ip) = gamlab*( prem0(3) +betlab*prem0(4) )
            PUP(4,ip) = gamlab*( betlab*prem0(3) +prem0(4) )
            PUP(5,ip) = amrem

            NUP= ip

         endif

C  Output the event data.
         if( lunwrit.gt.0 ) then
            if( ifmt.eq.0 ) then
               call lhaWritEvAsc(lunwrit)
            elseif( ifmt.eq.1 ) then
               call lhaWritEvBin(lunwrit)
            elseif( ifmt.eq.2 ) then
               call lhaWritEvLhef(lunwrit)
            endif
         endif

C  Check the hard interaction info. to verify the generation condition.
         etacm= log( GPRI(5)/GPRI(6) )/2.d0
C  Prompt gamma
         call pteta( pgrc(1,3), pt, eta )
         eta= etacm +eta
         call hf1(20,real(eta),1.)
         call hf1(21,real(pt),1.)
C  Jet
         call pteta( pgrc(1,4), pt, eta )
         eta= etacm +eta
         call hf1(22,real(eta),1.)
         call hf1(23,real(pt),1.)

      ENDDO

      WRITE(*,'(/'' ########## Event generation completed ##########''
     >     )')
      print *,'Total number of failure returns from PSKINI',
     >     nfail_pskini
      print *,'Do not warry unless too large; e.g., more than 1%.'
      print *,''

      print '('' Total xsec '',E12.4,'' pb'')', SUMXSEC
      print '('' Number of generated events  '',I10)', nevent
      print *,''

C  Close the event output file.
      if( lunwrit.gt.0 ) then
         if( ifmt.eq.2 ) then
            call lhaWritEndLhef(lunwrit)
         endif
         close(lunwrit)
      endif

C...Histograms.
      call histdo
C
C -- Store histograms.
C
      if( flhist(1:1).NE.'*' ) then
        call hrput(0,flhist,'N')
      endif

      stop
      END

      subroutine pteta( p, pt, eta )
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      real*8 p(3)

      pt2= p(1)**2 +p(2)**2
      pabs= sqrt( pt2 +p(3)**2 )
      pt= sqrt( pt2 )
      eta= log( ( pabs +abs( p(3) ) )/pt )
      if( p(3).lt.0.d0 ) eta= -eta

      return
      end

      real*8 function delta_r( p1, p2 )
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      real*8 p1(4),p2(4)

      call pteta( p1, pt1, eta1 )
      call pteta( p2, pt2, eta2 )
      csphi= ( p1(1)*p2(1) +p1(2)*p2(2) )/pt1/pt2
      if( csphi.gt.1.d0 ) csphi= 1.d0
      if( csphi.lt.-1.d0 ) csphi= -1.d0
      dphi= acos( csphi )
      delta_r= sqrt( dphi**2 +( eta1 -eta2 )**2 )

      return
      end
