      PROGRAM Pythia
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

      INTEGER PYK,PYCHGE,PYCOMP
C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Standard PYTHIA commonblocks.
      INTEGER N,NPAD,K
      REAL*8 P,V
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      INTEGER MSTU,MSTJ
      REAL*8 PARU,PARJ
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      INTEGER MDCY,MDME,KFDP
      REAL*8 BRAT
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      INTEGER MSEL,MSELPD,MSUB,KFIN
      REAL*8 CKIN
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
      INTEGER MSTP,MSTI
      REAL*8 PARP,PARI
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

      character*80 lhafile

      parameter ( lhcom = 100000 )
      real*4 h
      common /pawc/h(lhcom)
      character*72 flhist
      real*4 weight

C------------------------------------------------------------------
C  Cut to the generated events.
      parameter ( ptcut1= 25.d0, ptcut2= 40.d0 )
      parameter ( etacut= 2.5d0 )
      parameter ( amcut1= 80.d0, amcut2= 140.d0 )
C------------------------------------------------------------------
C  Delta-R for two-gamma separation.
      parameter ( drsepa= 0.4d0 )
C------------------------------------------------------------------
C  Isolation cut.
C      parameter ( driso= 0.4d0, etisocut= 3.0d0 )
      parameter ( driso= 0.4d0, etisocut= 15.0d0 )
C------------------------------------------------------------------
      real*8 evread(0:2),evacc(0:2)
      integer ipgam0(2),ipgam(10)
      real*8 pgam(4,2),pAA(4)
      real*8 etiso(2),ptest(4)

C  Original hard interaction information.
      integer nporig,iprorig,kforig
      real*8 porig
      common /info_orig/nporig,iprorig,kforig(10),porig(5,10)

C-----------------------------------------------------------------------
C  Output hbook file; "*" for no output.
C-----------------------------------------------------------------------
C      flhist= '*'
      flhist= 'hist.hbook'
C-----------------------------------------------------------------------
C  Number of events. 
C-----------------------------------------------------------------------
C      NEV = 10000
      NEV = 99999999                 ! Number of events
C-----------------------------------------------------------------------
C  PS/MI choice in Pythia.
C-----------------------------------------------------------------------
C      MSTP(61)  = 0   ! no ISR
C      MSTP(71)  = 0   ! no FSR
C      MSTP(81)  = 0   ! no MI, old PS when PYEVNT called
C      MSTP(81)  = 1   ! MI on, old PS when PYEVNT called (default)
C      MSTP(81)  = 20  ! no MI, new PS (= PYEVNW)
C      MSTP(81)  = 21  ! MI on, new PS (= PYEVNW)
C      MSTP(111) = 0   ! no hadronization
C-----------------------------------------------------------------------
C  Reset the energy-scale factor
C-----------------------------------------------------------------------
C  The default value of PARP(67) for the "old" PS is not suitable.
C  Comment out when the "new" PS is chosen.
      PARP(67)= 1.0    ! ISR energy scale factor for the "old" PS.
      PARP(71)= 1.0    ! FSR energy scale factor.
C-----------------------------------------------------------------------
C   PDF choice
C-----------------------------------------------------------------------
C      mstp(51)= 1         ! CTEQ3L
C      mstp(51)= 4         ! GRV 94L
C      mstp(51)= 7         ! CTEQ5L (default)
C      mstp(51)= 11        ! GRV 92L
C      mstp(51)= 12        ! EHLQ set 1
C      mstp(58)= 5         ! Nr. of flavor in PDF 
C-----------------------------------------------------------------------
C  Initialization
C-----------------------------------------------------------------------
C  UPINIT is called in PYINIT.
      CALL PYINIT('USER',' ',' ',0,0d0)
C-----------------------------------------------------------------------
C  Print out the parameters
C-----------------------------------------------------------------------
C  Basic control
      print *,'PS, multiple-interaction, hadronization:'
      print *,'  mstp(61, 71, 81, 111) =',mstp(61),mstp(71),
     >     mstp(81),mstp(111)
      print *,'PDF choice: mstp(51) =',mstp(51),
     >     ' with NF: mstp(58) =',mstp(58)

C  Energy scale factors
      print *,'Energy scale factors:'
      print '(5X,''parp(67), parp(71) ='',2F10.3)', parp(67),parp(71)

C  Multiple interaction
      print *,'Multiple interaction model: mstp(82) = ',mstp(82)
      print '(5X,''parp(82) ='',F10.3)', parp(82)
      print '(5X,''parp(83), parp(84) ='',2F10.3)', parp(83),parp(84)
      print '(5X,''parp(85), parp(86) ='',2F10.3)', parp(85),parp(86)
      print '(5X,''parp(89), parp(90) ='',2F10.3)', parp(89),parp(90)

C  Primordial kT
      print *,'Primordial kT mode: mstp(91) = ',mstp(91)
      print '(5X,''parp(91), parp(93) = '',2F10.3)',parp(91),parp(93)

C...Book histograms.
      call hlimit(lhcom)

      call hbook1(1,'Num of gammas (doc)$',20,0.,20.,0.)
      call hbook1(2,'dpsq1$',100,0.,100.,0.)
      call hbook1(3,'dpsq2$',100,0.,100.,0.)

      call hbook1(10,'pt of A1 (before cut)$',100,0.,100.,0.)
      call hbook1(11,'pt of A2 (before cut)$',100,0.,100.,0.)
      call hbook1(12,'eta of A1 (before cut)$',100,-5.,5.,0.)
      call hbook1(13,'eta of A2 (before cut)$',100,-5.,5.,0.)
      call hbook1(14,'Delta_R of AA (before cut)$',100,0.,5.,0.)
      call hbook1(15,'mass of AA (before cut)$',100,0.,200.,0.)

      call hbook1(20,'pt of A1$',100,0.,100.,0.)
      call hbook1(21,'pt of A2$',100,0.,100.,0.)
      call hbook1(22,'eta of A1$',100,-5.,5.,0.)
      call hbook1(23,'eta of A2$',100,-5.,5.,0.)
      call hbook1(24,'Delta_phi of AA$',20,0.,3.1416,0.)
      call hbook1(25,'Delta_eta of AA$',100,0.,5.,0.)
      call hbook1(26,'Delta_R of AA$',100,0.,5.,0.)
      call hbook1(27,'mass of AA$',100,0.,200.,0.)
      call hbook1(28,'pt of AA$',100,0.,200.,0.)
      call hbook1(29,'rapidity of AA$',100,-5.,5.,0.)

      call hbook1(30,'Delta_R of AJ (orig)$',100,0.,5.,0.)
      call hbook1(31,'pt(jet) when dR_AJ<dRiso (orig)$',100,0.,50.,0.)
      call hbook1(32,'m_AJ/pt0 (orig)$',100,0.,2.,0.)

      call hbook1(33,'ETiso of A1$',100,0.,100.,0.)
      call hbook1(34,'ETiso of A2$',100,0.,100.,0.)

      call hbook1(40,'pt of A1 (iso)$',100,0.,100.,0.)
      call hbook1(41,'pt of A2 (iso)$',100,0.,100.,0.)
      call hbook1(42,'eta of A1 (iso)$',100,-5.,5.,0.)
      call hbook1(43,'eta of A2 (iso)$',100,-5.,5.,0.)
      call hbook1(44,'Delta_phi of AA (iso)$',20,0.,3.1416,0.)
      call hbook1(45,'Delta_eta of AA (iso)$',100,0.,5.,0.)
      call hbook1(46,'Delta_R of AA (iso)$',100,0.,5.,0.)
      call hbook1(47,'mass of AA (iso)$',100,0.,200.,0.)
      call hbook1(48,'pt of AA (iso)$',100,0.,200.,0.)
      call hbook1(49,'rapidity of AA (iso)$',100,-5.,5.,0.)

      call hbook1(50,'Delta_R of AJ (orig)$',100,0.,5.,0.)
      call hbook1(51,'pt(jet) when dR_AJ<dRiso (orig)$',100,0.,50.,0.)
      call hbook1(52,'m_AJ/pt0 (orig)$',100,0.,2.,0.)

      call hbook1(53,'pt of AA (gam+q)$',100,0.,200.,0.)
      call hbook1(54,'Delta_phi of AA (gam+q)$',20,0.,3.1416,0.)
      call hbook1(55,'pt of AA (gam+g)$',100,0.,200.,0.)
      call hbook1(56,'Delta_phi of AA (gam+g)$',20,0.,3.1416,0.)

      call hbook1(60,'pt of 1st gam (input)$',100,0.,100.,0.)
      call hbook1(61,'eta of 1st gam (input)$',100,-5.,5.,0.)
      call hbook1(62,'pt of 2nd gam (input)$',100,0.,100.,0.)
      call hbook1(63,'eta of 2nd gam (input)$',100,-5.,5.,0.)
      call hbook1(64,'Delta_R of AA (input)$',100,0.,5.,0.)
      call hbook1(65,'mass of AA (input)$',100,0.,200.,0.)

      call hbook1(70,'pt of gam (orig)$',100,0.,100.,0.)
      call hbook1(71,'eta of gam (orig)$',100,-5.,5.,0.)

C  Sum of the cross sections.
      SUMXSEC = 0.0D0
      DO I = 1,NPRUP
         SUMXSEC = XSECUP(i) + SUMXSEC
      ENDDO

      do i=0,2
         evread(i)= 0.d0
         evacc(i)= 0.d0
      enddo

C...Event loop.
      DO IEV = 1,NEV

C  Event processing.
C  UPEVNT is called in PYEVNT; then, the PS and decay simulations are done 
C  according the parameter choice.
         CALL PYEVNT
         if( MSTI(51).ne.0 ) then
            print *,'MSTI(51) = ',MSTI(51)
            print *,'-> EOD signal from PYEVNT'
            goto 9000
         endif

         if( nporig.ne.5 ) then
            print *,'??? illegal num. of particles ',
     >           'in the original interaction ???'
            print *,' nporig = ',nporig
            stop
         endif

         evread(0)= evread(0) +1.d0
         if( kforig(4).ne.21 ) then
            iproc= 610
            evread(1)= evread(1) +1.d0
         else
            iproc= 611
            evread(2)= evread(2) +1.d0
         endif

         if( IEV.le.2 ) then
            call EUPdump
            CALL PYLIST(1)
         elseif( IEV.lt.1000 ) then
            if( mod(IEV,100).eq.0 ) print *,'Event# ',IEV
         elseif( IEV.lt.10000 ) then
            if( mod(IEV,1000).eq.0 ) print *,'Event# ',IEV
         else
            if( mod(IEV,10000).eq.0 ) print *,'Event# ',IEV
         endif

C  Document lines.
         ndoc= 0
         ngam0= 0
         pt1st= 0.d0
         pt2nd= 0.d0
         do i=1,N
            if( K(i,1).eq.21 ) then
               ndoc= i
               if( K(i,3).eq.0 ) then
                  idabs= iabs( K(i,2) )
                  if( idabs.eq.22 ) then
                     ngam0= ngam0 +1
                     pt= sqrt( P(i,1)**2 +P(i,2)**2 )
                     if( ngam0.eq.1 ) then
                        ipgam0(1)= i
                        pt1st= pt
                     else
                        if( pt.gt.pt1st ) then
                           ipgam0(2)= ipgam0(1)
                           ipgam0(1)= i
                           pt2nd= pt1st
                           pt1st= pt
                        elseif( pt.gt.pt2nd ) then
                           ipgam0(2)= i
                           pt2nd= pt
                        endif
                     endif
                  endif
               endif
            else
               goto 1
            endif
         enddo
 1       continue
         call hf1(1,ngam0+.5,1.)
         if( ngam0.lt.2 ) then
            call EUPdump
            CALL PYLIST(1)
            print *,'!!! Number of gammas less than 2 !!!'
            print *,'ngam0 = ',ngam0
            stop
         endif

C  Real records.
C  Two methods are provided in the following because the gamma in the 
C  real record sometimes does not point to a gamma in the documentation 
C  lines as the parent; this must be a bug in PYTHIA.
C         ichoice= 1
         ichoice= 2
C-------------------------------------------------------------------
         dpsq1= 1.d15
         dpsq2= 1.d15
         if( ichoice.eq.1 ) then
            ipgam(1)= 0
            ipgam(2)= 0
            do i=ndoc+1,N
               if( K(i,1).eq.1 .and. K(i,2).eq.22 ) then
                  imoth= K(i,3)
                  do ig=1,2
                     if( imoth.eq.ipgam0(ig) ) ipgam(ig)= i
                  enddo
               endif
            enddo
            if( ipgam(1).lt.1 .or. ipgam(2).lt.1 ) then
               CALL PYLIST(1)
               print *,'??? Corresponding gamma not found ',
     >              'in real record ???'
               print *,'gammas in doc = ',ipgam0
               stop
            endif
            i= ipgam(1)
            i0= ipgam0(1)
            dpsq1= ( P(i,1) -P(i0,1) )**2
     >           +( P(i,2) -P(i0,2) )**2
     >           +( P(i,3) -P(i0,3) )**2
            i= ipgam(2)
            i0= ipgam0(2)
            dpsq2= ( P(i,1) -P(i0,1) )**2
     >           +( P(i,2) -P(i0,2) )**2
     >           +( P(i,3) -P(i0,3) )**2
C-------------------------------------------------------------------
         else
            ngam= 0
            ipgam(1)= 0
            ipgam(2)= 0
            do i=ndoc+1,N
               if( K(i,1).eq.1 .and. K(i,2).eq.22 ) then
                  imoth= K(i,3)
                  if( imoth.le.ndoc ) then
                     ngam= ngam +1
                     i0= ipgam0(1)
                     dpsq= ( P(i,1) -P(i0,1) )**2
     >                    +( P(i,2) -P(i0,2) )**2
     >                    +( P(i,3) -P(i0,3) )**2
                     if( dpsq.lt.dpsq1 ) then
                        ipgam(1)= i
                        dpsq1= dpsq
                     endif
                     i0= ipgam0(2)
                     dpsq= ( P(i,1) -P(i0,1) )**2
     >                    +( P(i,2) -P(i0,2) )**2
     >                    +( P(i,3) -P(i0,3) )**2
                     if( dpsq.lt.dpsq2 ) then
                        ipgam(2)= i
                        dpsq2= dpsq
                     endif
                  endif
               endif
            enddo
            if( ngam.lt.2 ) then
               call EUPdump
               CALL PYLIST(1)
               print *,'!!! Number of gammas smaller than 2 !!!'
               print *,'ngam = ',ngam
               stop
            endif
            if( ipgam(1).eq.ipgam(2) ) then
               call EUPdump
               CALL PYLIST(1)
               print *,'!!! Proper gammas not found !!!'
               print *,'ipgam0 = ',ipgam0
               print *,'ipgam  = ',(ipgam(i),i=1,2)
               stop
            endif
         endif
         call hf1(2,real(dpsq1),1.)
         call hf1(3,real(dpsq2),1.)

C   Kinematical cut.
         do ig=1,2
            do i=1,4
               pgam(i,ig)= P(ipgam(ig),i)
            enddo
         enddo
         call pteta( pgam(1,1), pt1, eta1 )
         call pteta( pgam(1,2), pt2, eta2 )
         call hf1(10,real(pt1),1.)
         call hf1(11,real(pt2),1.)
         call hf1(12,real(eta1),1.)
         call hf1(13,real(eta2),1.)

         if( pt1.lt.ptcut1 .or. pt2.lt.ptcut1 ) goto 9
         if( pt1.lt.ptcut2 .and. pt2.lt.ptcut2 ) goto 9
         if( abs( eta1 ).gt.etacut 
     >        .or. abs( eta2 ).gt.etacut ) goto 9

         csdphi= ( pgam(1,1)*pgam(1,2) +pgam(2,1)*pgam(2,2) )/pt1/pt2
         if( csdphi.gt.1.d0 ) csdphi= 1.d0
         if( csdphi.lt.-1.d0 ) csdphi= -1.d0
         dphiAA= acos( csdphi )
         detaAA= eta2 -eta1
         dRAA= sqrt( dphiAA**2 +detaAA**2 )
         call hf1(14,real(dRAA),1.)

         if( dRAA.lt.drsepa ) goto 9

         do i=1,4
            pAA(i)= pgam(i,1) +pgam(i,2)
         enddo
         ptAA= sqrt( pAA(1)**2 +pAA(2)**2 )
         rapAA= log( ( pAA(4) +pAA(3) )/( pAA(4) -pAA(3) ) )/2.d0
         amAA= sqrt( pAA(4)**2 -pAA(3)**2 -pAA(2)**2 -pAA(1)**2 )
         call hf1(15,real(amAA),1.)

         if( amAA.lt.amcut1 .or. amAA.gt.amcut2 ) goto 9

         call hf1(20,real(pt1),1.)
         call hf1(21,real(pt2),1.)
         call hf1(22,real(eta1),1.)
         call hf1(23,real(eta2),1.)
         call hf1(24,real(dphiAA),1.)
         call hf1(25,real(detaAA),1.)
         call hf1(26,real(dRAA),1.)
         call hf1(27,real(amAA),1.)
         call hf1(28,real(ptAA),1.)
         call hf1(29,real(rapAA),1.)

C  Original hard interaction information.
         call pteta( porig(1,3), ptorig1, etaorig1 )
         call pteta( porig(1,4), ptorig2, etaorig2 )
         call pteta( porig(1,5), ptjorig, etajorig )

         dr1= delta_r( porig(1,3), porig(1,5) )
         dr2= delta_r( porig(1,4), porig(1,5) )
         if( dr1.le.dr2 ) then
            drAJ= dr1
         else
            drAJ= dr2
         endif

         am1= sqrt( ( porig(4,3) +porig(4,5) )**2
     >        -( porig(3,3) +porig(3,5) )**2
     >        -( porig(2,3) +porig(2,5) )**2
     >        -( porig(1,3) +porig(1,5) )**2 )
         am2= sqrt( ( porig(4,4) +porig(4,5) )**2
     >        -( porig(3,4) +porig(3,5) )**2
     >        -( porig(2,4) +porig(2,5) )**2
     >        -( porig(1,4) +porig(1,5) )**2 )
         if( am1.le.am2 ) then
            amAJ= am1
            pt0= ptorig2
         else
            amAJ= am2
            pt0= ptorig1
         endif
         rmAJ= amAJ/pt0

         call hf1(30,real(drAJ),1.)
         if( drAJ.lt.driso ) call hf1(31,real(ptjorig),1.)
         call hf1(32,real(rmAJ),1.)

C   Isolation
         etiso(1)= 0.d0
         etiso(2)= 0.d0
         do i=ndoc+1,N
            if( i.ne.ipgam(1) .and. i.ne.ipgam(2) 
     >           .and. K(i,1).eq.1 ) then
               idabs= iabs( K(i,2) )
               if( idabs.ne.12 .and. idabs.ne.14 .and. 
     >              idabs.ne.16 ) then
                  do j=1,4
                     ptest(j)= P(i,j)
                  enddo
                  et= P(i,4)*PYP( i, 10 )/PYP( i, 8 )
                  do ig=1,2
                     dr= delta_r( pgam(1,ig), ptest )
                     if( dr.lt.driso ) then
                        etiso(ig)= etiso(ig) +et
                     endif
                  enddo
               endif
            endif
         enddo
         call hf1(33,real(etiso(1)),1.)
         call hf1(34,real(etiso(2)),1.)

         if( etiso(1).gt.etisocut .or. etiso(2).gt.etisocut ) goto 9

C  Accepted.
         evacc(0)= evacc(0) +1.d0
         if( iproc.eq.610 ) evacc(1)= evacc(1) +1.d0
         if( iproc.eq.611 ) evacc(2)= evacc(2) +1.d0

         call hf1(40,real(pt1),1.)
         call hf1(41,real(pt2),1.)
         call hf1(42,real(eta1),1.)
         call hf1(43,real(eta2),1.)
         call hf1(44,real(dphiAA),1.)
         call hf1(45,real(detaAA),1.)
         call hf1(46,real(dRAA),1.)
         call hf1(47,real(amAA),1.)
         call hf1(48,real(ptAA),1.)
         call hf1(49,real(rapAA),1.)

         call hf1(50,real(drAJ),1.)
         if( drAJ.lt.driso ) call hf1(51,real(ptjorig),1.)
         call hf1(52,real(rmAJ),1.)

         if( iproc.eq.610 ) then
            call hf1(53,real(ptAA),1.)
            call hf1(54,real(dphiAA),1.)
         elseif( iproc.eq.611 ) then
            call hf1(55,real(ptAA),1.)
            call hf1(56,real(dphiAA),1.)
         endif

C  Check the input data.
         ngam= 0
         ip1st= 0
         pt1st= 0.d0
         ip2nd= 0
         pt2nd= 0.d0
         do i=1,NUP
            if( IDUP(i).eq.22 .and. ISTUP(i).eq.1 ) then
               ngam= ngam +1
               call pteta( PUP(1,i), pt, eta )
               if( ngam.eq.1 ) then
                  ip1st= i
                  pt1st= pt
               else
                  if( pt.gt.pt1st ) then
                     ip2nd= ip1st
                     pt2nd= pt1st
                     ip1st= i
                     pt1st= pt
                  elseif( pt.gt.pt2nd ) then
                     ip2nd= i
                     pt2nd= pt
                  endif
               endif
            endif
         enddo

         call pteta( PUP(1,ip1st), pt, eta )
         call hf1(60,real(pt),1.)
         call hf1(61,real(eta),1.)
         call pteta( PUP(1,ip2nd), pt, eta )
         call hf1(62,real(pt),1.)
         call hf1(63,real(eta),1.)
         drAA= delta_r( PUP(1,ip1st), PUP(1,ip2nd) )
         call hf1(64,real(drAA),1.)
         amAA= sqrt( ( PUP(4,ip1st) +PUP(4,ip2nd) )**2
     >        -( PUP(3,ip1st) +PUP(3,ip2nd) )**2
     >        -( PUP(2,ip1st) +PUP(2,ip2nd) )**2
     >        -( PUP(1,ip1st) +PUP(1,ip2nd) )**2 )
         call hf1(65,real(amAA),1.)

C  Check the generation condition.
         call hf1(70,real(ptorig1),1.)
         call hf1(71,real(etaorig1),1.)

C...End of loop over events.
 9       continue
      ENDDO

 9000 continue
      WRITE(*,'(/'' ########## Analysis completed ##########''
     >     )')
      print '('' Cross section of the generation = '',E12.6,
     >     '' pb'')', SUMXSEC
      evgen= evread(0)
      print '(F10.0,'' events read'')',evgen
      print '('' ----------------------------------------'')'
      do i=0,2
         if( i.eq.0 ) then
            print *,'Total'
         elseif( i.eq.1 ) then
            print *,'gamma + q'
         else
            print *,'gamma + g'
         endif
         print '(F10.0,'' events accepted out of '',
     >        F10.0,'' events'')', evacc(i),evread(i)
         if( evread(i).gt.0.d0 ) then
            eff= evacc(i)/evread(i)
            efferr= sqrt( eff*( 1.d0 -eff )/evread(i) )
            print '('' efficiency = '',F6.4,'' +- '',F6.4)',eff,efferr
            efftot= evacc(i)/evgen
            xsec= SUMXSEC*efftot
            xerr= SUMXSEC*sqrt( efftot*( 1.d0 -efftot )/evgen )
            print '('' cross section = '',E12.6,'' +-'',E12.6,
     >           '' pb'')', xsec,xerr
         else
            print '(5X,''No input!'')'
         endif
         print '('' ----------------------------------------'')'
      enddo
      print *,'Cross section errors do not include the error in BASES.'
      print *,''

C...Cross section table.
      CALL PYSTAT(1)

C...Histograms.
      call histdo
C
C -- Store histograms.
C
      if( flhist(1:1).NE.'*' ) then
        call hrput(0,flhist,'N')
      endif

      stop
      END

      subroutine pteta( p, pt, eta )
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      real*8 p(3)

      pt2= p(1)**2 +p(2)**2
      pabs= sqrt( pt2 +p(3)**2 )
      pt= sqrt( pt2 )
      eta= log( ( pabs +abs( p(3) ) )/pt )
      if( p(3).lt.0.d0 ) eta= -eta

      return
      end

      real*8 function delta_r( p1, p2 )
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      real*8 p1(4),p2(4)

      call pteta( p1, pt1, eta1 )
      call pteta( p2, pt2, eta2 )
      csphi= ( p1(1)*p2(1) +p1(2)*p2(2) )/pt1/pt2
      if( csphi.gt.1.d0 ) csphi= 1.d0
      if( csphi.lt.-1.d0 ) csphi= -1.d0
      dphi= acos( csphi )
      delta_r= sqrt( dphi**2 +( eta1 -eta2 )**2 )

      return
      end

      SUBROUTINE UPINIT
C  An "LhaExt" version of UPINIT.
C
C  This routine opens a data file, reads in the "run information" from the 
C  header records, and skips siecified number of events.
C  LUNs for the control file and the data file, and other control parameters 
C  must be given in a read-control file named "lharead_control.txt".
C
C  June 8, 2004, S. Odaka (KEK)
      IMPLICIT NONE

      integer lunctl,lundat,ifmt
      common /lharead/lunctl,lundat,ifmt

      character*80 lhactl
      parameter ( lhactl= 'lharead_control.txt' )
      integer lun,idwt,nSkip,iev
      integer lun1,lun2

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

      print *,' '
      print *,'============================== UPINIT =====',
     >     '=================================='

C  Open the control file.
      lun= 10
      call lunfind( lun )
      lunctl= lun
      open(lunctl,file=lhactl,status='OLD')
      print '('' LHA control file opened: LUN = '',I3)',lunctl
      print '(''   file name = '',A80)',lhactl

C  Read the 1st line: LUNs for the control file and the data file.
      read(lunctl,*) lun1,lun2
      if( lun1.ge.1 ) then
         close( lunctl )
         lunctl= lun1
         print '('' LUN for the control file reassigned: LUN = '',
     >        I3)',lunctl
         open(lunctl,file=lhactl,status='OLD')
         read(lunctl,*) lun1
      endif

C  Read the 2nd line: the parameter for the weighting strategy.
      read(lunctl,*) idwt
      print '('' Specified weighting strategy = '',I3)',idwt
      if( idwt.eq.0 ) then
         print *,'   -> no overwrite'
      else
         print *,'   -> overwrite'
      endif

C  Read the 3rd line: number of events to skip.
      read(lunctl,*) nSkip
      print '('' First '',I3,'' events will be skipped.'')',nSkip

C  Open the 1st data file.
      if( lun2.ge.1 ) then
         lundat= lun2
      else
         call lunfind( lun )
         lundat= lun
      endif
      print '('' Input data file: LUN = '',I3)',lundat

      call lhaopen( lunctl, lundat, ifmt, *9 )

C  Update the run information.
      print *,'Read the header record'
      if( ifmt.eq.0 ) then
         call lhaReadHdAsc( lundat, 0 )
      elseif( ifmt.eq.1 ) then
         call lhaReadHdBin( lundat, 0 )
      endif

C  Overwrite the weighting strategy parameter if specified.
      if( idwt.ne.0 ) IDWTUP= idwt
      print '('' -> weighting strategy = '',I3)',IDWTUP

C  Skip specified number of events.
      if( nSkip.gt.0 ) then
         do iev=1,nSkip
            call lhaReadEvnt(lunctl,lundat,ifmt,*8)
         enddo
         print '('' First '',I3,'' events skipped.'')',nSkip
      endif

      print *,'===========================================',
     >     '=================================='

      return

 8    continue
      print *,'End-of-data during the event skip -> stop'
      stop

 9    continue
      print *,'(error) no input-data file given'
      stop

      end

      subroutine lunfind( lun )
      integer lun
      logical lopen

 1    inquire( lun, opened=lopen )
      if( lopen ) then
         lun= lun +1
         goto 1
      endif

      return
      end

      subroutine lhaopen( lunctl, lundat, ifmt, * )

      character*10 filefmt
      character*80 filename

C  Read the information for the 1st data file.
      call lhactlrd( lunctl, filefmt, filename, *9 )
      print '('' New input file: format = '',A10)',filefmt
      print '(''   file name = '',A80)',filename

C  Open the 1st data file.
      if( filefmt(1:3).eq.'asc' ) then
         ifmt= 0
         open(lundat,file=filename,form='FORMATTED',status='OLD')
      elseif( filefmt(1:3).eq.'bin' ) then
         ifmt= 1
         open(lundat,file=filename,form='UNFORMATTED',status='OLD')
      endif

      print *,'   -> successfully opened'

      return

 9    return 1

      end

      subroutine lhactlrd( lunctl, filefmt, filename, * )

      character*10 filefmt
      character*80 filename
      character*80 string

 1    read(lunctl,'(A80)',end=9) string
C      print *,'Input string:'
C      print '(A80)',string

      if( string(1:1).eq.'*' ) goto 1
      if( string(1:4).eq.'end ' .or. string(1:4).eq.'End '
     >     .or. string(1:4).eq.'END ' ) goto 9

      isep= 0
      do i=1,80
         isep= isep +1
         if( string(isep:isep).eq.':' ) goto 2
      enddo
      print *,'LHACTLRD (error): no separator in the control list'
      stop

 2    continue
      filefmt= string(1:isep-1)
      filename= string(isep+1:80)

      return

 9    continue
      print *,'LHACTLRD: end of the control list'
      return 1

      end

      SUBROUTINE UPEVNT
C  An "LhaExt" version of UPEVNT.
C
C  This routine reads in one event from a data file.
C  The actual read action is done by "lhaReadEvnt".
C  The end-of-data of the input is signaled to the calling routine by
C  setting NUP = 0.
C
C  June 8, 2004, S. Odaka (KEK)
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

      integer lunctl,lundat,ifmt
      common /lharead/lunctl,lundat,ifmt

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

C  Original hard interaction information.
      integer nporig,iprorig,kforig
      real*8 porig
      common /info_orig/nporig,iprorig,kforig(10),porig(5,10)

C  Read an event record.
 1    continue
      call lhaReadEvnt(lunctl,lundat,ifmt,*9)

C  Move the added info to a separate arrays.
      iprorig= IDPRUP
      nporig= 0
      do i=1,NUP
         if( ISTUP(i).ge.100 ) then
            nporig= nporig +1
            kforig(nporig)= IDUP(i)
            ISTUP(i)= 0
            IDUP(i)= 0
            do j=1,5
               porig(j,nporig)= PUP(j,i)
               PUP(j,i)= 0.d0
            enddo
         endif
      enddo
      NUP= NUP -nporig
      if( NUP.gt.80 ) then
         print *,'Skip an event because too many particles read: ',
     >        'NUP= ',NUP
         goto 1
      endif

      return

C  No more file to read.
 9    continue
      NUP= 0
      return

      END
