      subroutine plqcd2j(imode,isel)
      implicit none

      INCLUDE 'inclk.h'
      INCLUDE 'grchad.inc'

      INTEGER MXDIM,NDMX,NDIM,NWILD,IG,NCALL,ITMX1,ITMX2
      DOUBLE PRECISION XL,XU,ACC1,ACC2
      PARAMETER (MXDIM = 50, NDMX = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     $     IG(MXDIM),NCALL
      COMMON /BPARM2/ ACC1,ACC2,ITMX1,ITMX2

      INTEGER JPROC
      COMMON /AMJPRC/JPROC

      CHARACTER GRCPROC*40
      COMMON/GRCCHAR/GRCPROC

      INTEGER i,imode,isel
      real*8  xsn(10),rna
      integer imrg,ijrg

C...Decide subprocess ID.
      if (imode.eq.1) then
         ijrg = 300
         imrg = 8
         xsn(2) = 0.20d0
         xsn(3) = 0.40d0
         xsn(4) = 0.50d0
         xsn(5) = 0.60d0
         xsn(6) = 0.70d0
         xsn(7) = 0.80d0
         xsn(8) = 0.90d0
C...Inclusive heavy flavor production.
         if (igjflv(7).eq.0) then
            imrg = 6
            xsn(2) = 0.30d0     ! 304
            xsn(3) = 0.50d0     ! 305
            xsn(4) = 0.70d0     ! 306
            xsn(5) = 0.80d0     ! 307
            xsn(6) = 0.90d0     ! 308
         endif
C...top quark production.
         if (igjflv(1)+igjflv(2)+igjflv(3)+igjflv(4)
     $        +igjflv(5)+igjflv(7).eq.0.and.igjflv(6).eq.1) then
            imrg = 2
            xsn(2) = 0.50d0     ! 304
         endif
         rna = xrun(5)
         xsn(1) = 0.0d0
         xsn(imrg+1) = 1.0d0
         do i = 1,imrg
            if (rna.gt.xsn(i).and.rna.le.xsn(i+1)) then
               gpri(10) = (rna-xsn(i))/(xsn(i+1)-xsn(i))
               yacob = yacob/(xsn(i+1)-xsn(i))
               jproc = i + ijrg
            endif
         enddo
C...top quark production.
         if (igjflv(1)+igjflv(2)+igjflv(3)+igjflv(4)
     $        +igjflv(5)+igjflv(7).eq.0.and.igjflv(6).eq.1) then
            if (jproc.eq.302) jproc = 304
            if (jproc.eq.301) jproc = 302
C...Inclusive heavy flavor production.
         else if (igjflv(7).eq.0) then
            if (jproc.eq.306) jproc = 308
            if (jproc.eq.305) jproc = 307
            if (jproc.eq.304) jproc = 306
            if (jproc.eq.303) jproc = 305
            if (jproc.eq.302) jproc = 304
            if (jproc.eq.301) jproc = 302
         endif

C...Set dimension and process character.
      else if (imode.eq.2) then
         ndim = 6
         if (isel.eq.182) grcproc = 'pp(bar) -> 2 jets (QCD2)'
         if (isel.eq.301) grcproc = 'gg -> gg (QCD2)'
         if (isel.eq.302) grcproc = 'qq -> qq (QCD2)'
         if (isel.eq.303) grcproc = 'qq -> gg (QCD2)'
         if (isel.eq.304) grcproc = 'gg -> qq (QCD2)'
         if (isel.eq.305) grcproc = 'qg -> qg (QCD2)'
         if (isel.eq.306) grcproc = 'qq -> qq (QCD2)'
         if (isel.eq.307) grcproc = 'qq -> qq (QCD2)'
         if (isel.eq.308) grcproc = 'qq -> qq (QCD2)'

C...Initialize kinematic parameter.
      else if (imode.eq.3) then
	 mxreg = 1
	 ktype = 2201
	 cxtype = 1234
	 gtau(1) = 1
	 gtau(14) = 2
	 gyst(1) = 1
	 gyst(14) = 5
	 gcos3(1) = 1
	 gcos3(14) = 4

C...Set flavor and if necessary, decide weight of each phase space.
      else if (imode.eq.4) then
         isel = 1
      endif

      return
      end
